	program   magn
c***********************************************************************
	include 'hinclude.f'
c       hier:      nx, ny, nz, nv, ndiag, nbeob  und
c       common:    mhdfeld, hfeld, gitter, rkoeff, korand, progr,
c                  diagn1 und diagn2
c
        	
        integer          ksafe,msafe,nix,niy,nvp,nvm
	character*8      magtapn
        character*26     comagt
c................................................................
c   main program loop, open and close, formatted output, etc
c................................................................
c
c    -----------------------------------
c     i)  start organized in orgstart
c    -----------------------------------
c      magtapn='magtapn'
c      tapno='123456789'
c      outno='123456789'
      call orgstart
      write(*,*) 'ende orgstart-1'
      msafe=0
      ldiag = ldiag + 1
      tdiag(ldiag) = zeit
      call diag1
      call diag2
c    -----------------------------------
c     ii)  start of integration (first 2 steps
c    -----------------------------------
  400 newdt=.false.
      call intstart
      if ( fehler ) go to 900
      if ( ischritt .ge. iend) goto 900
c    -----------------------------------
c     iii) diagnostics and output
c    -----------------------------------
 500  if (mod(ischritt,200).eq.0) write(22,58) ischritt,zeit
c    -----------------------------------
c     a) diagnostics 
c    -----------------------------------
      if ( mod(ischritt,idiag) .eq. 0 )  then
        call turbo
        call fac
	if (ldiag .ge. ndiag) then
	    call diagout
	    ldiag = 0
	end if
	ldiag = ldiag + 1
	tdiag(ldiag) = zeit
	call diag1
	call diag2
        if (mod(ischritt,2*idiag) .eq. 0) call diag3
        if (mod(ischritt,2*idiag) .eq. 0) call diag4
      end if
c    -----------------------------------
c     b) satellites
c    -----------------------------------
      if ( zeit .ge. tsat0 .and. mitsat)  then
        if (.not. startsat) call satstart
        call satdat
      endif
c    -----------------------------------
c     c) binary output
c    -----------------------------------
      ksafe = mod(ischritt,isafe)
      if ( ksafe.eq.0 .or. newdt) then
         igrid=1
	 call lax
	 call randv
	 call randb
	 call abbruch
	 if (newdt) then
	  dt=0.9*dt
c	  idiag=int(1/dt)
	 endif
	 if ( fehler .and. ifehler.le.nglatt ) call oglatt
	 if ( fehler ) go to 900

	 if ( ksafe .eq. 0 ) then
	 msafe=msafe+1
c	 magtapn(7:7)=tapno(msafe:msafe)
         write(magtapn,1969) msafe
         write(comagt,1970) msafe
 1969    format('magtap',i2.2)
 1970    format('-a magtap',i2.2,' -F f77 -N ieee')
	 open (14,file=magtapn,form='unformatted')
c         call asnunit(14,comagt,ier)
         write(14)   nx,ny,zeit,npos,nrow
         write(14)   xa,dxa,ddxa,ddpxa,ddmxa,mpxa,mmxa,
     +               ya,dya,ddya,ddpya,ddmya,mpya,mmya
         write(14)   bx,by,bz
         write(14)   sx,sy,sz
         write(14)   rho,u,res,prof
         write(14)   ischritt,iout,isafe,iend,intart,ivisrho,nglatt,
     +               nout,ifehler,igrid,idiag,
     +               fehler,dt,gamma,eta,visx,visy,
     +               phi,bmsh,pmsp,kappa,rho0,delrho,xrho,dxrho,
     +               delbz,by0,bz0,bzmsp,bzmsh,pmsh,betasp,betash,
     +               vamsp,vamsh,csmsp,csmsh,v0,v1,
     +               vyr,vzr,byr,bzr,rhoprof,uprof,
     +               perio,lsym,kbx,kby,kbz,ksx,ksy,ksz,
     +               arho,au,abx,aby,abz,asx,asy,asz,
     +               xmin,xmax,ymin,ymax,aequi,zentr,eps,
     +               nsim,bsim,vsim,psim,lsim,tsim,
     +               rhobd,pbd,vxbd,vybd,vzbd,bxbd,bybd,bzbd,
     +               tsatout,zeitsat,xsat,ysat,vxsat,vysat
c         call assign('assign -R')
	 close (14)
	 write(22,52) ischritt
	 end if
      end if
c
      if ( ischritt .ge. iend) goto 900
      if ( ksafe.eq.0 .or. newdt) goto 400
c     
c    -----------------------------------
c     iv) main integration procedure
c    -----------------------------------
      call orgint
      if ( fehler ) goto 900
c
      goto 500
c    -----------------------------------
c     v) closing procedure
c    -----------------------------------
  900 call diagout
c
      close (15)
      close (17)
      close (18)
      close (22)
      close (23)
      close (24)
      close (25)
      close (26)
      close (27)
      close (28)
      close (29)
      close (30)
      close (38)
      if ( startsat)  then
c        call assign('assign -R')
        close (39)
        close (31)
        close (32)
        close (33)
        close (34)
        close (35)
        close (36)
      endif
    1 format(1x,l10)
   52 format(1x,'daten xyz gesichert',i5)
   54 format(1x,'orgout xyz gerufen',i5)
   58 format(1x,'at integrationstep:',i6,'   time:',f8.2)
c
c  liste der subroutines:
c ------------------------
c main magn:
c	block data vorbes0
c	 orgstart
c	 intstart
c	 satstart
c	 satdat
c	 interp(dxsat,dysat,finter,fout)
c	 orgint
c	 oglatt
c	 lespar
c	 schreib
c	 grid
c	 anfang
c	 orgout
c	 out(aname)
c	 glatt
c	 meanlax
c	 lax
c	 leap
c	 rdcoef
c	 rand
c	 abbruch
c	 diag1
c	 diagout
c
      stop
      end
	block data vorbes0
c
	include 'hinclude.f'
c.................................................................
      data    mass/ndiag*0./,massu/ndiag*0./,enthe/ndiag*0./,
     +        enmag/ndiag*0./,enkin/ndiag*0./,
     +        vgradp/ndiag*0./, vdjxb/ndiag*0./, resj2/ndiag*0./,
     +        ekinpu/ndiag*0./, ethpu/ndiag*0./, ebpu/ndiag*0./
     +        fphi/ndiag*0./,fphip/ndiag*0./,fphipi/ndiag*0./,
     +        fphipr/ndiag*0./,
     +        frho/ndiag*0./,fekin/ndiag*0./,fethe/ndiag*0./,
     +        feb/ndiag*0./,febi/ndiag*0./,febr/ndiag*0./,
     +        bneu/0./,qneu/0./,qnneu/0./,tneu/0./
      data    tsatout/1.0/,zeitsat/0.0/,
     +        xpos/npos*0./,ypos/npos*0./,zpos/npos*0./,
     +        dxpos/npos*0./,dypos/npos*0./,dzpos/npos*0./,
     +        vxpos/npos*0./,vypos/npos*0./,vzpos/npos*0./,
     +        xsat/nsat*0./,ysat/nsat*0./,zsat/nsat*0./,
     +        vxsat/nsat*0./,vysat/nsat*0./,vzsat/nsat*0./,
     +        bxs/nsat*0./,bys/nsat*0./,bzs/nsat*0./,
     +        vxs/nsat*0./,vys/nsat*0./,vzs/nsat*0./,
     +        rhosat/nsat*0./,psat/nsat*0./,bsat/nsat*0./,
     +        ptotsat/nsat*0./
      data    fini/.false./,start/.true./,etasw/0/,
     +        mitsat/.true./,fehler/.false./,newdt/.false./,
     +        ischritt/0/,iout/800/,isafe/800/,iend/8000/,intart/1/,
     +        ivisrho/1200/,nglatt/80/,nout/0/,
     +        ifehler/0/,igrid/1/,
     +        ldiag/0/,idiag/40/,tdiag/ndiag*0./,
     +        dt/.025/,zeit/0./,gamma/1.667/,
     +        eta/0.02/,visx/0.02/,visy/0.02/,visz/0.02/
      end
	subroutine orgstart
c
	include 'hinclude.f'
        integer anzx,anzy,anzpos,anzrow

c	
c..........................................
c    startprocedures:
c         -determine parameters 
c         -fix boundary conditions
c         -fix initial conditions
c..........................................
c
c   additional files in program:
c     14=magtap(n)  21=magout(n)  21=magou1  (all in main)
c     31=sat1       32=sat2       33=sat3
c     34=sat4       35=sat5       36=sat6    (all in satstart)
c
      open (15,file='magin')
      open (17,file='magdia1')
      open (18,file='magdia2')
      open (22,file='magpar')
      open (23,file='magdmax')
      open (24,file='magdxl')
      open (25,file='magdgrow')
      open (26,file='magdcur')
      open (27,file='magdfl1')
      open (28,file='magdfl2')
      open (29,file='magdfte')
      open (30,file='magdturbo')
      open (37,file='magvz')
      open (38,file='magkhgrow')
      write(17,37)
      write(18,38)
      write(23,43)
      write(24,44)
      write(25,45)
      write(27,47)
      write(28,48)
      write(29,49)
      write(38,45)
      
c
      rewind 15
      read (15,1)  start
      write(22,99)
   99 format(1x,'at start')
c    -----------------------------------------------------------
c     i) start of program by 
c            a: analytical equilibrium (start = true)
c            b: tapedata (start = false)
c             note: binary output and input must be identical!!
c    -----------------------------------------------------------
      if(start)  then
c   a: analytical equilibrium (start = true)
c......determine parameters
c 
	 call lespar
	 ifehler = 0
	 ischritt = 0
	 zeit = 0.
c......determine grid
	 call grid
c......determine boundary conditions
	 call rdcoef
c......determine initial conditions
	 call anfang
	 fehler = .false.
c......check timestep
  150    continue      
	 if ( (zentr(1)) .and. dt .lt. 0.5/difx((nx+1)/2) .or.
     +        (.not.(zentr(1))) .and. dt .lt. 0.5/difx(2) ) go to 200
         write(*,*)'dt',dt
	 dt = .5*dt
	 go to 150
  200    continue
      else
c   b: tapedata (start = false)
c......same as above for tapedata
c       
	 open (14,file='magtap',form='unformatted')
c         call asnunit(14,'-a magtap -F f77 -N ieee',ier)
	 read(14) anzx,anzy,zeit,anzpos,anzrow
	 if ( anzx.ne.nx .or. anzy.ne.ny 
     +        .or. anzpos.ne.npos .or. anzrow.ne.nrow )  then
	     write(22,11)  anzx,anzy,anzpos,anzrow
	     stop
         end if
         read(14)  xa,dxa,ddxa,ddpxa,ddmxa,mpxa,mmxa,
     +             ya,dya,ddya,ddpya,ddmya,mpya,mmya
         read(14)  bx,by,bz
         read(14)  sx,sy,sz
         read(14)  rho,u,res,prof
         read(14)  ischritt,iout,isafe,iend,intart,ivisrho,nglatt,
     +             nout,ifehler,igrid,idiag,
     +             fehler,dt,gamma,eta,visx,visy,
     +             phi,bmsh,pmsp,kappa,rho0,delrho,xrho,dxrho,
     +             delbz,by0,bz0,bzmsp,bzmsh,pmsh,betasp,betash,
     +             vamsp,vamsh,csmsp,csmsh,v0,v1,
     +             vyr,vzr,byr,bzr,rhoprof,uprof,
     +             perio,lsym,kbx,kby,kbz,ksx,ksy,ksz,
     +             arho,au,abx,aby,abz,asx,asy,asz,
     +             xmin,xmax,ymin,ymax,aequi,zentr,eps,
     +             nsim,bsim,vsim,psim,lsim,tsim,
     +             rhobd,pbd,vxbd,vybd,vzbd,bxbd,bybd,bzbd,
     +             tsatout,zeitsat,xsat,ysat,vxsat,vysat
c         call assign('assign -R')
	 close (14)
        zeit0=zeit

        do 210 ix = 1,nx
	do 210 iy = 1,ny
	  iv = ix + (iy-1)*nx
	  x(iv)      = xa(ix)
	  difx(iv)   = dxa(ix)
	  ddifx(iv)  = ddxa(ix)
	  ddifpx(iv) = ddpxa(ix)
	  ddifmx(iv) = ddmxa(ix)
	  meanpx(iv) = mpxa(ix)
	  meanmx(iv) = mmxa(ix)
  210   continue

        do 220 ix = 1,nx
	do 220 iy = 1,ny
	  iv = ix + (iy-1)*nx
	  y(iv)      = ya(iy)
	  dify(iv)   = dya(iy)
	  ddify(iv)  = ddya(iy)
	  ddifpy(iv) = ddpya(iy)
	  ddifmy(iv) = ddmya(iy)
	  meanpy(iv) = mpya(iy)
	  meanmy(iv) = mmya(iy)
  220   continue

	call lespar
        call rdcoef
      end if

      startsat=.false.
      call schreib
      if (mitsat .and. tsat0 .eq. 0.) then 
       call satstart
       call satdat
      endif
c
      write(26,56) ny-2
      iv1 = 2*nx
      iv2 = 10*nx
   21 write(26,57) (y(iv),iv=iv1,iv2,nx)
	iv1 = iv1+9*nx
	iv2 = iv2+9*nx
	if(iv2.ge.nv) iv2 = nv-nx
      if(iv1.le.nv-nx) goto 21

      write(*,*) 'ende orgstart'
    1 format(1x,l10)
c
   11 format(1x,'!!!warning!!!',
     +       /1x,'gridnumbers: nx=',i4,'  ny=',i4,
     +       /1x,'or satparameters: npos=',i4,'  nrow=',i4,
     +       /1x,'are not identical with programparameters',
     +       /1x,'!!!warning!!!')
c
c
   37 format(/1x,' time  !   mass     !  mass  msp !',
     +           '  kin ener  !  mag ener  !  the energ',
     +       /1x,'-------!------------!------------!',
     +           '------------!------------!------------')
c
   38 format(/1x,' time  !v grad p/2!v dot jxb !res mal j2!',
     +                    'd/dt ekin ! d/dt eb  ! d/dt eth ',
     +       /1x,'-------!----------!----------!----------!',
     +                    '----------!----------!----------')
c
   43 format(/1x,' TIME  ',
     +       /1x,' MAXIMUM !   X   !    Y  !',
     +           ' MINIMUM !   X   !    Y  !',
     +       /1x,'---------!-------!-------!',
     +           '---------!-------!-------!')
c
   44 format(/1x,' time!xo! x x-l  ! y x-l  ! vy x-l !',
     +        ' current! e field!  slope !  flux  ! no',
     +       /1x,'-----!--!--------!--------!--------!',
     +           '--------!--------!--------!--------!---')
c
   45 format(/2x,'  time  !   bn     !  width   !  rate q  !',
     +                    'qt=qw**1.5!  qn=q*w  !  dqt/dt   ',
     +       /2x,'--------!----------!----------!----------!',
     +                    '----------!----------!----------')
c
   47 format(/1x,' time  !  mag flux  ! flux change!',
     +           ' rate ideal ! rate resist',
     +       /1x,'-------!------------!------------!',
     +           '------------!--------------')
c
   48 format(/1x,' time  !flux: mass! kin. en. ! the. en. !',
     +                    '  b. en.  !ideal.con.! res. con.',
     +       /1x,'      ratio of flux to magnetic flux  => ',
     +                    '                                ',
     +       /1x,'-------!----------!----------!----------!',
     +                    '----------!----------!----------')
c
   49 format(1x,' time  !  pmax  !   xp   !   zp   !',
     +            '  rho  !   bx   !   by   !   bz   !',
     +      /1x,'--------!  bxmax !  xbmax !  zbmax !',
     +            '------!   vx   !   vy   !   vz   !',
     +      /1x,'---------!  bxmin !  xbmin !  zbmin !',
     +            '!!  difb  !  difx  !  difz  !',
     +      /1x,'-----------------------------------------',
     +                    '------------------------------')
c
   56 format(/2x,' x coordinates and current density of the',
     +           ' field reversal at the following',
     +       /2x,' y coordinates with ny=',/,I5)
   57 format(9(f8.2))
c
      return
      end
	subroutine intstart
c
	include 'hinclude.f'
c............................................................
c       integration of mhd-equations:
c          1. integr. step =  lax-step
c          the lax-step is always on grid 1 
c          (igrid=1). the leap-step is for the two-step 
c          lax-wendroff method only on grid 0.
c          the leapfrog method employs alternately both grids
c............................................................
c
c    the first two integrationsteps:
c...............................................
c
      write(22,61) ischritt
   61 format(1x,'Starting integration, integrationstep',i5)

      igrid = 1
      call lax
      call randv
      call randb

      ischritt = ischritt + 1
      zeit = zeit + dt
      write(22,62) ischritt
      write(*,62) ischritt
c      call stuff
   62 format(1x,'output after first laxstep, intstep',i5)

      call abbruch
      if ( fehler .and. ifehler.le.nglatt ) call oglatt
      if ( fehler ) return
c
      igrid = 0
      call leap
      write(22,*) ischritt, 'vor rand'
      call randv
      call randb


      
c      call trb
c
      ischritt = ischritt + 1
      zeit = zeit + dt
      write(22,63) ischritt
c      write(*,63) ischritt
   63 format(1x,'output after first leapstep, intstep',i5)

      write(22,*) ischritt, 'vor abbruch'
      call abbruch
      write(22,*) ischritt, 'hinter abbruch'
      if ( fehler .and. ifehler.le.nglatt ) call oglatt
c
c      write(6,60) ischritt
c   60 format(1x,'integrationstep',i5)
c
      return
      end
	subroutine satstart
c
        integer   i,j,k,fnum
	include  'hinclude.f'

      startsat = .true.
      zeitsat = zeit
      open (31,file='sat1')
      open (32,file='sat2')
      open (33,file='sat3')
      open (34,file='sat4')
      open (35,file='sat5')
      open (36,file='sat6')
c
c   zpos,dzpos, vzpos are not relevant
c    needed to have 3D format and vz needed 
c     to transform to magnetospheric rest frame
c
      do 50 i = 1,npos
      do 50 j = 1,nrow  
         k = j + (i-1)*nrow
         xsat(k) = xpos(i) + (j-1)*dxpos(i)
         ysat(k) = ypos(i) + (j-1)*dypos(i)
         zsat(k) = zpos(i) + (j-1)*dzpos(i)
         vxsat(k) = vxpos(i)
         vysat(k) = vypos(i)
         vzsat(k) = vzpos(i)
   50 continue

      do 60 i = 1,npos
        fnum = 30+i
	write(fnum,21) i,zeitsat
        write(fnum,211)  nsim,bsim,vsim,psim,lsim,tsim
        write(fnum,212)  rhobd(1),pbd(1),vxbd(1),vybd(1),vzbd(1),
     +                   bxbd(1),bybd(1),bzbd(1),
     +                   rhobd(2),pbd(2),vxbd(2),vybd(2),vzbd(2),
     +                   bxbd(2),bybd(2),bzbd(2)
	write(fnum,22) 
        do 61 j = 1,nrow
          k = j + (i-1)*nrow
          write(fnum,23) j,xsat(k),ysat(k),zsat(k),
     +                     vxsat(k),vysat(k),vzsat(k)
   61   continue
        write(fnum,24) 
        write(fnum,25) 
   60 continue
   
      open (39,file='satbin',form='unformatted')
c      call asnunit(39,'-a satbin -F f77 -N ieee',ier)
      write(39) nsat,zeitsat
      write(39) nsim,bsim,vsim,psim,lsim,tsim
      write(39) rhobd,pbd,vxbd,vybd,vzbd,bxbd,bybd,bzbd
      write(39) xsat,ysat,zsat,vxsat,vysat,vzsat

      do 70 i = 1,npos
      do 70 j = 1,nrow  
         k = j + (i-1)*nrow
         vysat(k) = vypos(i) + vybd(1)
         vzsat(k) = vzpos(i) + vzbd(1)
   70 continue

   21 format(1x,'satellite set          start time',/1x,i10,f18.3)
  211 format(/1x,'Normalisation for : ',
     +       /1x,' No density ! magn. field!  velocity  !  pressure  !',
     +           'length units!    time     ',
     +       /1x,'  cm**(-3)  !     nT     !    km/s    !   nPascal  !',
     +           '     km     !      s      ',
     +         /,f11.2,f13.2,f13.2,f13.4,f13.2,f13.4)
  212 format(/1x,'Initial asymptotic values at xmin (1. row) ',
     +           'and xmax (2. row) for: ',
     +       /1x,'    rho      p        vx       vy       vz    ',
     +           '   bx       by       bz    ',
     +       /,8f9.3/,8f9.3)
   22 format(/1x,'Initial satellite locations and velocity:',
     +       /1x,'sat  !    x    !    y    !    z    !',
     +                 '    vx   !    vy   !    vz   ')
   23 format(1x,i3,'   ',f7.2,'   ',f7.2,'   ',f7.2,
     +             '   ',f7.2,'   ',f7.2,'   ',f7.2)
   24 format(1x,'Satellite velocity is relative to restframe of the',
     +            ' magnetosphere (at xmin)!!!',
     +       /1x,'Plasma velocity is recorded in the satellite frame!')
   25 format(/1x,'  time   bx     by     bz     vx     vy     vz   ',
     +        'rhosat  psat    bsat   ptot')

      return
      end
	subroutine satdat
c
	include 'hinclude.f'

        integer ix,iy,ixi,iyi,ivi,k,ixsat,iysat,fnum
        real    philm,dxsat(3),dysat(3),
     +          bxint(2,2),byint(2,2),bzint(2,2), 
     +          sxint(2,2),syint(2,2),szint(2,2), 
     +          rhoint(2,2),pint(2,2),
     +          bxout,byout,bzout,sxout,syout,szout,rhoout,pout 
              
      tsat0 = tsat0+tsatout
      philm = atan(by0/(bz0+delbz))
      do 5 i = 1,npos
      do 5 j = 1,nrow  
         k = j + (i-1)*nrow
         xsat(k) = xsat(k) + (zeit-zeitsat)*vxsat(k)
         ysat(k) = ysat(k) + (zeit-zeitsat)*vysat(k)
         zsat(k) = zsat(k) + (zeit-zeitsat)*vzsat(k)
    5 continue

      do 50 i = 1,npos
       fnum = 30+i
       do 50 j = 1,nrow
        k = j + (i-1)*nrow
        ixsat = 2
        iysat = 2
        do 10 ix = 2,nx-1
   10     if(xsat(k).ge.x(ix)) ixsat = ix
        do 20 iy = 2,ny-1
   20     if(ysat(k).ge.y(iy*nx)) iysat = iy
        dxsat(1) = x(ixsat+1)-xsat(k)
        dysat(1) = y(nx*(iysat+1))-ysat(k)
        dxsat(2) = xsat(k)-x(ixsat)
        dysat(2) = ysat(k)-y(nx*iysat)
        dxsat(3) = x(ixsat+1)-x(ixsat)
        dysat(3) = y(nx*(iysat+1))-y(nx*iysat)

        if(xsat(k).lt.xmin) then
          xsat(k) = xmin
          ixsat = 2
          dxsat(1) = x(3)-x(2)
          dxsat(2) = 0.0
          dxsat(3) = x(3)-x(2)
        else if (xsat(k).gt.xmax) then
          xsat(k) = xmax
          ixsat = nx-1
          dxsat(1) = x(nx)-x(nx-1)
          dxsat(2) = 0.0
          dxsat(3) = x(nx)-x(nx-1)
        end if

        if(ysat(k).lt.ymin) then
          if (perio(2)) then 
            ysat(k)=ysat(k)+(ymax-ymin)
          else
            ysat(k) = ymin
            iysat = 2
            dysat(2) = 0.0
            dysat(1) = y(3*nx)-y(2*nx)
            dysat(3) = y(3*nx)-y(2*nx)
          endif
        endif
        if (ysat(k).gt.ymax) then
          if (perio(2))  then
            ysat(k)=ysat(k)-(ymax-ymin)
          else
            ysat(k) = ymax
            iysat = ny-1
            dysat(1) = y(nv)-y(nv-nx)
            dysat(2) = 0.0
            dysat(3) = y(nv)-y(nv-nx)
          endif
        endif

        do 40 ixi = 0,1
        do 40 iyi = 0,1
         ivi = ixi+ixsat+(iyi+iysat-1)*nx
         bxint(ixi+1,iyi+1)  = bx(ivi)
         byint(ixi+1,iyi+1)  = by(ivi)
         bzint(ixi+1,iyi+1)  = bz(ivi)
         sxint(ixi+1,iyi+1)  = sx(ivi)
         syint(ixi+1,iyi+1)  = sy(ivi)
         szint(ixi+1,iyi+1)  = sz(ivi)
         rhoint(ixi+1,iyi+1) = rho(ivi)
         pint(ixi+1,iyi+1)   = 2*u(ivi)**gamma
   40   continue

        call interp(dxsat,dysat,bxint,bxout)
        call interp(dxsat,dysat,byint,byout)
        call interp(dxsat,dysat,bzint,bzout)
        call interp(dxsat,dysat,sxint,sxout)
        call interp(dxsat,dysat,syint,syout)
        call interp(dxsat,dysat,szint,szout)
        call interp(dxsat,dysat,rhoint,rhoout)
        call interp(dxsat,dysat,pint,pout)

	bxs(k) =  bxout
	bys(k) =  byout
	bzs(k) =  bzout
	vxs(k) =  sxout/rhoout-vxsat(k)
	vys(k) =  syout/rhoout-vysat(k)
	vzs(k) =  szout/rhoout-vzsat(k)
	rhosat(k) = rhoout
	psat(k) = pout
	bsat(k) = sqrt( bxout*bxout+byout*byout+bzout*bzout )
	ptotsat(k) = psat(k) + bsat(k)*bsat(k)

   50 continue

      do 60 i = 1,npos
        fnum = 30+i
        do 60 j = 1,nrow
          k = j + (i-1)*nrow
	  write(fnum,11) zeit,bxs(k),bys(k),bzs(k),vxs(k),vys(k),vzs(k),
     +                        rhosat(k),psat(k),bsat(k),ptotsat(k)
   60 continue
      write(39) zeit,bxs,bys,bzs,vxs,vys,vzs,rhosat,psat,bsat,
     +               xsat,ysat,zsat
      
      zeitsat = zeit

   11 format(1x,f6.2,10f7.3)

      return
      end
	subroutine interp(dxsat,dysat,finter,fout)

        real    dxsat(3),dysat(3),finter(2,2),fout

      fout = ( dxsat(1)*dysat(1)*finter(1,1)
     +       + dxsat(1)*dysat(2)*finter(1,2)
     +       + dxsat(2)*dysat(1)*finter(2,1)
     +       + dxsat(2)*dysat(2)*finter(2,2) )
     +                          / ( dxsat(3)*dysat(3) )
      return
      end
	subroutine orgint
c
	include 'hinclude.f'
c................................................................
c
c  1) leapfrog integration:
c.................................
c
      if (intart .eq. 1) then
	 igrid = 1
	 call leap
         call randv
         call randb
	 ischritt = ischritt + 1
	 zeit = zeit + dt
c      if (ischritt .ge. 1398) write(*,*) ischritt, 'hinter rand'
	 call abbruch
	 if ( fehler .and. ifehler.le.nglatt ) call oglatt
c	 if ( fehler ) return

	 igrid = 0
	 call leap
         call randv
         call randb
	 ischritt = ischritt + 1
	 zeit = zeit + dt
c      call trb
	 if(mod(ischritt,1000).eq.0)  write(6,60) ischritt,zeit
	 call abbruch
	 if ( fehler .and. ifehler.le.nglatt ) call oglatt
	  
      end if
c
c
c  2) lax-wendroff integration:
c.....................................
c
      if (intart .eq. 2) then
	 igrid = 1
	 call meanlax
         call randv
         call randb
	 call lax
         call randv
         call randb
	 ischritt = ischritt + 1
	 zeit = zeit + dt
	 call abbruch
	 if ( fehler .and. ifehler.le.nglatt ) call oglatt
	 if ( fehler ) return

	 igrid = 0
	 call leap
         call randv
         call randb
	 ischritt = ischritt + 1
	 zeit = zeit + dt
c	 write(6,60) ischritt
c 	 call symtx
	 call abbruch
	 if ( fehler .and. ifehler.le.nglatt ) call oglatt
      end if
c
   60 format(1x,'integrationstep:',i5,'  time:',f8.2)
c
      return
      end
	subroutine oglatt
c
	include 'hinclude.f'
c       hier:      nx, ny, nz, nv, ndiag
c       common:    mhdfeld, hfeld, gitter, rkoeff, korand, progr,
c.................................................................
      ifehler = ifehler + 1
      write(22,1) ifehler
      write(*,1) ifehler
      fehler = .false.

      call glatt
      igrid = 1-igrid
      call randv
      call randb
      igrid = 1-igrid
      call randv
      call randb
      call abbruch
	  if ( fehler .and. ifehler.le.nglatt ) then
        ifehler = ifehler + 1
        write(22,2) ifehler
        write(*,2) ifehler
        call glatt
        igrid = 1-igrid
        call randv
        call randb
        igrid = 1-igrid
        call randv
        call randb
      endif
c
    1 format(1x,'Anzahl der glaettungen: ',i3)
    2 format(1x,'Second ERROR, Anzahl der glaettungen: ',i3)
      return
      end
	subroutine lespar
c
	include 'hinclude.f'
c
	logical  ldum
	integer  idum, i, j
	real     rdum
c.....................................................
        read (15,2) etasw
        write(*,*)'etasw',etasw
        read (15,1) mitsat
        write(*,*)'mitsat',mitsat
        read (15,2) iout,isafe,iend
        write (*,*)  iout,isafe,iend

      if (start) then
	read (15,2) intart,ivisrho,nglatt,nout,idiag
c	write (6,2)  intart,ivisrho,nglatt,nout,idiag
	read (15,3) dt,gamma,eta,jcrit
c	write (6,3)  dt,gamma,eta
	read (15,4) visx,visy
c	write (6,4)  visx,visy
      else
	 read (15,2) idum,idum,idum,idum,idum
	 read (15,3) rdum,rdum,rdum,rdum
	 read (15,4) rdum,rdum
      end if

      if (start) then
	read (15,4) xmin,xmax,ymin,ymax
        read (15,4) psi,phi,bmsh,pmsp,kappa,rho0,delrho,xrho,dxrho,
     +               v0,v1
	read (15,4) nsim,bsim,lsim
	write (6,4) nsim,bsim,lsim
	read (15,1) aequi(1),aequi(2)
        read (15,1) zentr(1),zentr(2)
        read (15,3) eps(1),eps(2)
      else
	read (15,4) rdum,rdum,rdum,rdum
	read (15,4) rdum,rdum,rdum,rdum,rdum,rdum,rdum,rdum,rdum,
     +              rdum,rdum
        read (15,4) rdum,rdum,rdum
	read (15,1) ldum,ldum
	read (15,1) ldum,ldum
	read (15,3) rdum,rdum
      end if

c      write (6,4)  xmin,xmax,ymin,ymax
c      write (6,4)  phi,bmsh,pmsp,kappa,rho0,delrho,xrho,dxrho
c      write (6,1)  aequi(1),aequi(2)
c      write (6,1)  zentr(1),zentr(2)
c      write (6,3)  eps(1),eps(2)

      if (start)  then
        read (15,1) perio(1),perio(2)
c        write (6,1)  perio(1),perio(2)
        read (15,1) lsym(1,1),lsym(2,1),lsym(1,2),lsym(2,2)
c        write (6,1)  lsym(1,1),lsym(2,1),lsym(1,2),lsym(2,2)
        do 50 j = 1,2
        do 50 i = 1,2
	   read(15,2) kbx(i,j),kby(i,j),kbz(i,j),
     +                 ksx(i,j),ksy(i,j),ksz(i,j)
	   read(15,3) arho(i,j),au(i,j),ares(i,j),
     +                 abx(i,j),aby(i,j),abz(i,j),
     +                 asx(i,j),asy(i,j),asz(i,j)
   50   continue
      else
	read (15,1) ldum,ldum
	read (15,1) ldum,ldum,ldum,ldum
        do 55 j = 1,4
          read (15,2) idum,idum,idum,idum,idum,idum
	  read (15,3) rdum,rdum,rdum,rdum,rdum,rdum,rdum,rdum,rdum
   55   continue
      end if
      
      if (mitsat) then
        read(15,4) tsat0,tsatout
        write(6,4) tsat0,tsatout
	do 100 i = 1,npos
          read(15,4) xpos(i),ypos(i),zpos(i),  
     +               dxpos(i),dypos(i),dzpos(i),
     +               vxpos(i),vypos(i),vzpos(i)
  100   continue
      end if
c
    1 format(1x,l10)
    2 format(1x,i9)
    3 format(1x,f14.8)
    4 format(1x,f14.5)
c
      return
      end
	subroutine schreib
c
	include 'hinclude.f'
c
	integer  i, j, ix, iy
c.....................................................
      write(22,10)  ischritt
      write(22,11)  nx,ny,
     +               iout,isafe,iend,intart,ivisrho,nglatt,nout,
     +               ifehler,igrid,idiag,mitsat,tsat0
      write(22,12)  dt,gamma,eta,jcrit,visx,visy,
     +               xmin,ymin,xmax,ymax
      if (etasw.eq.1) write(22,121)
      if (etasw.eq.2) write(22,122)
      if (etasw.eq.3) write(22,123)
      write(22,13)  psi,phi,bmsh,pmsp,kappa,
     +               rho0,delrho,xrho,dxrho,by0,bz0,delbz,
     +               bzmsp,bzmsh,pmsp,pmsh,betasp,betash,
     +               vamsp,vamsh,csmsp,csmsh,
     +               v0,v1
      write(22,131)  rhobd(1),pbd(1),vxbd(1),vybd(1),vzbd(1),
     +                bxbd(1),bybd(1),bzbd(1),
     +                rhobd(2),pbd(2),vxbd(2),vybd(2),vzbd(2),
     +                bxbd(2),bybd(2),bzbd(2)
      write(22,132)  nsim,bsim,vsim,psim,lsim,tsim
      write(22,14)  aequi(1),aequi(2),
     +               zentr(1),zentr(2),
     +               eps(1),eps(2)
      write(22,15)  perio(1),perio(2),
     +               lsym(1,1),lsym(2,1),lsym(1,2),lsym(2,2)
      do 100 j = 1,2
      do 100 i = 1,2
	 write(22,16) i,j,
     +                 kbx(i,j),kby(i,j),kbz(i,j),
     +                 ksx(i,j),ksy(i,j),ksz(i,j),
     +                 arho(i,j),au(i,j),ares(i,j),
     +                 abx(i,j),aby(i,j),abz(i,j),
     +                 asx(i,j),asy(i,j),asz(i,j)
  100 continue

      do 101 j = 1,2
      do 101 i = 1,2
	write(22,17) i,j,
     +    crho1(i,j),crho2(i,j),cu1(i,j),cu2(i,j),
     +    cres1(i,j),cres2(i,j),
     +    cbx1(i,j),cbx2(i,j),cby1(i,j),cby2(i,j),cbz1(i,j),cbz2(i,j),
     +    csx1(i,j),csx2(i,j),csy1(i,j),csy2(i,j),csz1(i,j),csz2(i,j)
  101 continue
c
        write(22,8891)
        do 1011 ix = 1,nx
 	 write(22,8881) x(ix),difx(ix),ddifx(ix),ddifpx(ix),ddifmx(ix),
     +                  meanpx(ix),meanmx(ix)
 1011   continue
        write(22,8892)
        do 1012 iy = 1,ny
 	 write(22,8881) y(iy*nx),dify(iy*nx),ddify(iy*nx),
     +                  ddifpy(iy*nx),ddifmy(iy*nx),
     +                  meanpy(iy*nx),meanmy(iy*nx)
 1012   continue
c
c
   10 format(/1x,'programm parameter(intschritt=',i5,') : ',
     +       /1x,'---------------------------------------')
c
   11 format(/1x,'nx     =',i5,3x,'ny      =',i5,3x,
     +       /1x,'iout   =',i5,3x,'isafe   =',i5,3x,'iend   =',i5,3x,
     +       /1x,'intart =',i5,3x,'ivisrho =',i5,3x,'nglatt =',i5,3x,
     +       /1x,'nout   =',i5,3x,'ifehler =',i5,3x,'igrid  =',i5,3x,
     +           'idiag  =',i5,3x,'mitsat  =',l3,3x,'tsat0  =',f6.1)
c
   12 format(/1x,'timeschritt =',f9.5,3x,'gamma =',f9.5,
     +       /1x,'resistivitaet =',f9.5,3x,'jcrit =',f9.5,
     +       /1x,'visx =',f9.5,3x,'visy =',f9.5,
     +       /1x,'xmin =',f9.3,3x,'ymin =',f9.3,
     +       /1x,'xmax =',f9.3,3x,'ymax =',f9.3)
c
  121 format(/1x,'resistivity is time dependent')
  122 format(/1x,'resistivity is parameter dependent')
  123 format(/1x,'resistivity is time independent')
c
   13 format(/1x,' equilibrium   parameter : ',
     +       /1x,'---------------------------',
     +       /1x,'psi   =',f7.2,3x,'phi   =',f7.2,3x,'bmsh   =',f7.2,3x,
     +           'pmsp  =',f7.2,3x,'kappa  =',f7.2,
     +       /1x,'rho0  =',f7.2,3x,'delrho =',f7.2,3x,
     +           'xrho  =',f7.2,3x,'dxrho  =',f7.2,
     +       /1x,'damit folgen:  by0 =',f8.3,3x,'  bz0 =',f8.3,3x,
     +           'delbz =',f8.3,
     +       /1x,'                !      msp      !      msh      ! ',
     +       /1x,'--------------------------------------------------',
     +       /1x,'  bz            ! ',f12.5,'  ! ',f12.5,'  !',
     +       /1x,'  p             ! ',f12.5,'  ! ',f12.5,'  !',
     +       /1x,'  beta          ! ',f12.5,'  ! ',f12.5,'  !',
     +       /1x,'  v-alfven      ! ',f12.5,'  ! ',f12.5,'  !',
     +       /1x,'  v-sound       ! ',f12.5,'  ! ',f12.5,'  !',
     +       /1x,' flow velocity     v0:', f12.5, 
     +       /1x,'      perturbation v1:', f12.5)

  131 format(/1x,'Initial asymptotic values at xmin (1. row) ',
     +           'and xmax (2. row) in simulation coordinates',
     +       /1x,'    rho      p        vx       vy       vz    ',
     +           '   bx       by       bz    ',
     +       /,8f9.3/,8f9.3)
  132 format(/1x,' Reasonable normalisation for : ',
     +       /1x,' No density ! magn. field!  velocity  !  pressure  !',
     +           'length units!    time     ',
     +       /1x,'  cm**(-3)  !     nT     !    km/s    !   nPascal  !',
     +           '     km     !      s      ',
     +       /1x,f11.2,' !',f11.2,' !',f11.2,' !',f11.4,' !',
     +           f11.2,' !',f11.4)

   14 format(/1x,'aequidistantes grid   in       x:',l3,8x,'y:',l3,
     +       /1x,'max resolution im centerr for  x:',l3,8x,'y:',l3,
     +       /1x,'spacing in grid                x:',f7.3,
     +        4x,'y:',f7.3)

   15 format(/1x,'periodic boundary conditions in  x:',l4,3x,
     +        'in y:',l4,
     +       /1x,'linesymmetrie (along z) at    xmin:',l4,
     +        3x,'xmax:',l4,
     +       /1x,'              (along x) at    ymin:',l4,
     +        3x,'ymax:',l4)

   16 format(/1x,'min/max = ',i4,5x,'x/y = ',i4,
     +       /1x,'kbx  =',i4,3x,'kby  =',i4,3x,'kbz  =',i4,3x,
     +       /1x,'ksx  =',i4,3x,'ksy  =',i4,3x,'ksz  =',i4,3x,
     +       /1x,'arho =',f5.2,2x,'au   =',f5.2,2x,'ares =',f5.2,2x,
     +       /1x,'abx  =',f5.2,2x,'aby  =',f5.2,2x,'abz  =',f5.2,2x,
     +       /1x,'asx  =',f5.2,2x,'asy  =',f5.2,2x,'asz  =',f5.2,2x)
c
   17 format(/1x,'min/max = ',i4,5x,'x/y = ',i4,
     +       /1x,'crho1=',f5.2,2x,'crho2=',f5.2,2x,
     +           'cu1  =',f5.2,2x,'cu2  =',f5.2,2x,
     +           'cres1=',f5.2,2x,'cres2=',f5.2,2x,
     +       /1x,'cbx1 =',f5.2,2x,'cbx2 =',f5.2,2x,
     +           'cby1 =',f5.2,2x,'cby2 =',f5.2,2x,
     +           'cbz1 =',f5.2,2x,'cbz2 =',f5.2,2x,
     +       /1x,'csx1 =',f5.2,2x,'csx2 =',f5.2,2x,
     +           'csy1 =',f5.2,2x,'csy2 =',f5.2,2x,
     +           'csz1 =',f5.2,2x,'csz2 =',f5.2)
c
 8881 format(1x,7f10.4)
 8891 format(/3x,'  x         dif       ddif      ddifp     ddifm',
     +           '     meanp     meanm ')
 8892 format(/3x,'  y         dif       ddif      ddifp     ddifm',
     +           '     meanp     meanm ')
c
      return
      end
	subroutine grid
c
	include 'hinclude.f'
c
	integer  iv,ivs,ix,iy,iv0,ix0,iy0
	real     kx,ky,xanf,yanf,
     +           beta,a1,a2,w,w1,w2
c .................................................................
c     gitter berechnet die gitterparameter, welche der integration
c         zugrunde liegen.
c         ( x senkrecht zur stromschicht -  n koordinate
c           y ostrichtung                - -m koordinate
c           z nordrichtung               -  l koordinate )
c .................................................................
c
c  berechnung der gitterparameter der x-koordinate
c  (y und z aehnlich) ueber die funktion:
c         x  =  w + a1*sin(beta*w) + a2*sin(2*beta*w)
c         w  =  kx*(ix-ix0)
c         kx =  2.*xmax/(nx-3) ; ix0 = (nx+1)/2
c         beta = pi/xmax
c         a1,a2 ergeben sich out vorgabe des gitterabstandes
c               bei x=0 (eps(1))
c         difx - gewicht der 1. ableitung
c         ddifx, ddifpx und ddifmx - gewichte der 2. ableitung
c ..............................................................
c      write(*,991)
 991  format('vor x gitter')
      kx =  (xmax-xmin)/(nx-3)
      xanf = xmin
      ix0 = 2
      beta = pi/(xmax-xmin)
      if (zentr(1)) then
	xanf = (xmin+xmax)/2.0
	ix0 = (nx+1)/2
	beta = 2*pi/(xmax-xmin)
      end if
      a1 = 0.0
      a2 = 0.0
      if (.not. aequi(1)) then
	a1 = 4./3.*(eps(1)-kx)/kx/beta
	a2 = (kx-eps(1))/6./kx/beta
      end if
c.......................................
      do 200 ix = 1,nx
         w      =  kx*(ix-ix0)
	 x(ix)  =  w + a1*sin(beta*w) + a2*sin(2*beta*w)
	 difx(ix) = 0.5/kx/(1. + a1*beta*cos(beta*w)
     +                       + 2.*a2*beta*cos(2.*beta*w))
         w1 = w + 0.5*kx
	 w2 = w - 0.5*kx
	 ddifpx(ix) = 2.*difx(ix)/kx/(1. + a1*beta*cos(beta*w1)
     +                       + 2.*a2*beta*cos(2.*beta*w1))
	 ddifmx(ix) = 2.*difx(ix)/kx/(1. + a1*beta*cos(beta*w2)
     +                       + 2.*a2*beta*cos(2.*beta*w2))
         ddifx(ix) = .5*(ddifpx(ix)+ddifmx(ix))
  200 continue
c
c berechnung der gewichte fuer mittelungen:
c...........................................
      do 250 ix = 2,nx-1
	 meanmx(ix) = (x(ix+1)-x(ix))/(x(ix+1)-x(ix-1))
	 meanpx(ix) = (x(ix)-x(ix-1))/(x(ix+1)-x(ix-1))
  250 continue
      meanmx(1)   = meanpx(3)
      meanpx(1)   = meanmx(3)
      meanmx(nx)  = meanpx(nx-2)
      meanpx(nx)  = meanmx(nx-2)
c
c symmetrie fuer zentrierte nichtaequidistantes gitter:
c.......................................................
      if (zentr(1))   then
	do 260 ix = 1, ix0
	  x(ix)      = ( x(ix)-x(nx+1-ix) )/2.0
	  difx(ix)   = ( difx(ix)+difx(nx+1-ix) )/2.0
	  ddifpx(ix) = ( ddifpx(ix)+ddifmx(nx+1-ix) )/2.0
	  ddifmx(ix) = ( ddifmx(ix)+ddifpx(nx+1-ix) )/2.0
	  ddifx(ix)  = ( ddifx(ix)+ddifx(nx+1-ix) )/2.0
	  meanpx(ix) = ( meanpx(ix)+meanmx(nx+1-ix) )/2.0
	  meanmx(ix) = ( meanmx(ix)+meanpx(nx+1-ix) )/2.0
  260   continue
	  x(ix0) = 0.0
	  ddifpx(ix0) = ( ddifpx(ix0)+ddifmx(ix0) )/2.0
	  ddifmx(ix0) = ( ddifpx(ix0)+ddifmx(ix0) )/2.0
	  ddifx(ix0) =  ( ddifpx(ix0)+ddifmx(ix0) )/2.0
	  meanpx(ix0) = ( meanpx(ix0)+meanmx(ix0) )/2.0
	  meanmx(ix0) = ( meanpx(ix0)+meanmx(ix0) )/2.0
	do 270 ix = ix0+1, nx
	  x(ix)      = -x(nx+1-ix)
	  difx(ix)   = difx(nx+1-ix)
	  ddifpx(ix) = ddifmx(nx+1-ix)
	  ddifmx(ix) = ddifpx(nx+1-ix)
	  ddifx(ix)  = ddifx(nx+1-ix)
	  meanpx(ix) = meanmx(nx+1-ix)
	  meanmx(ix) = meanpx(nx+1-ix)
  270   continue
      end if
      if (.not. zentr(1))   then      
        do 300 ix = 1, nx
	  x(ix) = xanf + x(ix)
  300   continue
      end if
c
c  belegung der randwerte der gitterparameter:
c..............................................
      x(1)        = 2.*xmin - x(3)
      x(nx)       = 2.*xmax -x(nx-2)
      x(2)        = xmin
      x(nx-1)     = xmax
      difx(1)     = difx(3)
      difx(nx)    = difx(nx-2)
      ddifmx(2)   = ( ddifpx(2) + ddifmx(2) ) / 2.0
      ddifmx(nx-1)= ( ddifpx(nx-1) + ddifmx(nx-1) ) / 2.0
      ddifpx(2)   = ddifmx(2)
      ddifpx(nx-1)= ddifmx(nx-1)
      ddifmx(1)   = ddifpx(3)
      ddifpx(1)   = ddifmx(3)
      ddifmx(nx)  = ddifpx(nx-2)
      ddifpx(nx)  = ddifmx(nx-2)
      meanmx(1)   = meanpx(3)
      meanpx(1)   = meanmx(3)
      meanmx(nx)  = meanpx(nx-2)
      meanpx(nx)  = meanmx(nx-2)
c
      do 310 ix = 1,nx
	  xa(ix)    = x(ix)
	  dxa(ix)   = difx(ix)
	  ddxa(ix)  = ddifx(ix)
	  ddpxa(ix) = ddifpx(ix)
	  ddmxa(ix) = ddifmx(ix)
	  mpxa(ix)  = meanpx(ix)
	  mmxa(ix)  = meanmx(ix)
  310 continue

      do 350 ix = 1,nx
	do 350 iy = 2,ny
	  iv = ix + (iy-1)*nx
	  x(iv)      = x(ix)
	  difx(iv)   = difx(ix)
	  ddifx(iv)  = ddifx(ix)
	  ddifpx(iv) = ddifpx(ix)
	  ddifmx(iv) = ddifmx(ix)
	  meanpx(iv) = meanpx(ix)
	  meanmx(iv) = meanmx(ix)
  350 continue

      if (zentr(1))   then
	do 360 iy = 1,ny
	do 360 ix = 1,nx
	  iv  = ix+(iy-1)*nx
	  ivs = 1+iy*nx-ix
	  if ( meanpx(iv) .ne. meanmx(ivs) )
     +      write(22,21) ix,iy,meanpx(iv),meanmx(ivs),zeit
	  if ( ddifpx(iv) .ne. ddifmx(ivs) )
     +      write(22,22) ix,iy,ddifpx(iv),ddifmx(ivs),zeit
  360   continue
      end if
   21 format(' meanpx(',i3,',',i3,') =',f12.7,
     +       '   und',f12.7,'   time =',f9.4)
   22 format(' ddifpx(',i3,',',i3,') =',f12.7,
     +       '   und',f12.7,'   time =',f9.4)

c.......................................................
c  berechnung der gitterparameter der y-koordinate
c      analog zu x
c.......................................................
      ky =  (ymax-ymin)/(ny-3)
      yanf = ymin
      iy0 = 2
      iv0 = 2*nx
      beta = pi/(ymax-ymin)
      if (zentr(2)) then
	yanf = (ymin+ymax)/2.0
	iy0 = (ny+1)/2
	iv0 = iy0*nx
	beta = 2*pi/(ymax-ymin)
      end if
      a1 = 0.0
      a2 = 0.0
      if (.not. aequi(2)) then
	a1 = 4./3.*(eps(2)-ky)/ky/beta
	a2 = (ky-eps(2))/6./ky/beta
      end if
c.......................................
      do 400 iy = 1,ny
	 iv = iy*nx
         w      =  ky*(iy-iy0)
	 y(iv)  =  w + a1*sin(beta*w) + a2*sin(2*beta*w)
	 dify(iv) = 0.5/ky/(1. + a1*beta*cos(beta*w)
     +                       + 2.*a2*beta*cos(2.*beta*w))
         w1 = w + 0.5*ky
         w2 = w - 0.5*ky
	 ddifpy(iv) = 2.*dify(iv)/ky/(1. + a1*beta*cos(beta*w1)
     +                       + 2.*a2*beta*cos(2.*beta*w1))
	 ddifmy(iv) = 2.*dify(iv)/ky/(1. + a1*beta*cos(beta*w2)
     +                       + 2.*a2*beta*cos(2.*beta*w2))
	 ddify(iv) = .5*(ddifpy(iv)+ddifmy(iv))
  400 continue
c
c  berechnung der gewichte fuer mittelungen:
c............................................
c
      do 450 iy = 2,ny-1
	 iv = iy*nx
	 meanmy(iv) = (y(iv+nx)-y(iv))/(y(iv+nx)-y(iv-nx))
	 meanpy(iv) = (y(iv)-y(iv-nx))/(y(iv+nx)-y(iv-nx))
  450 continue
      meanmy(1*nx) = meanpy(3*nx)
      meanpy(1*nx) = meanmy(3*nx)
      meanmy(nv)   = meanpy(nv-2*nx)
      meanpy(nv)   = meanmy(nv-2*nx)
c
c symmetrie fuer zentrierte nichtaequidistantes gitter:
c.......................................................
      if (zentr(2))   then
	do 460 iv = nx, iv0, nx
	  y(iv)      = ( y(iv)-y(nv+nx-iv) )/2.0
	  dify(iv)   = ( dify(iv)+dify(nv+nx-iv) )/2.0
	  ddifpy(iv) = ( ddifpy(iv)+ddifmy(nv+nx-iv) )/2.0
	  ddifmy(iv) = ( ddifmy(iv)+ddifpy(nv+nx-iv) )/2.0
	  ddify(iv)  = ( ddify(iv)+ddify(nv+nx-iv) )/2.0
	  meanpy(iv) = ( meanpy(iv)+meanmy(nv+nx-iv) )/2.0
	  meanmy(iv) = ( meanmy(iv)+meanpy(nv+nx-iv) )/2.0
  460   continue
	  y(iv0) = 0.0
	  ddifpy(iv0) = ( ddifpy(iv0)+ddifmy(iv0) )/2.0
	  ddifmy(iv0) = ( ddifpy(iv0)+ddifmy(iv0) )/2.0
	  ddify(iv0) =  ( ddifpy(iv0)+ddifmy(iv0) )/2.0
	  meanpy(iv0) = ( meanpy(iv0)+meanmy(iv0) )/2.0
	  meanmy(iv0) = ( meanpy(iv0)+meanmy(iv0) )/2.0
	do 470 iv = iv0+nx, nv, nx
	  y(iv)      = -y(nv+nx-iv)
	  dify(iv)   = dify(nv+nx-iv)
	  ddifpy(iv) = ddifmy(nv+nx-iv)
	  ddifmy(iv) = ddifpy(nv+nx-iv)
	  ddify(iv)  = ddify(nv+nx-iv)
	  meanpy(iv) = meanmy(nv+nx-iv)
	  meanmy(iv) = meanpy(nv+nx-iv)
  470   continue
      end if
      if (.not. zentr(2))   then
        do 500 iv = nx, nv, nx
	  y(iv) = yanf + y(iv)
  500   continue
      end if
c
c  belegung der randwerte der gitterparameter:
c...............................................
      y(1*nx)      = 2.*ymin - y(3*nx)
      y(nv)        = 2.*ymax - y(nv-2*nx)
      y(2*nx)      = ymin
      y(nv-nx)     = ymax
      dify(1*nx)   = dify(3*nx)
      dify(nv)  = dify((ny-2)*nx)
      ddifmy(2*nx) = ( ddifpy(2*nx) + ddifmy(2*nx) ) / 2.0
      ddifmy(nv-nx)= ( ddifpy(nv-nx) + ddifmy(nv-nx) ) / 2.0
      ddifpy(2*nx) = ddifmy(2*nx)
      ddifpy(nv-nx)= ddifmy((ny-1)*nx)
      ddifmy(1*nx) = ddifpy(3*nx)
      ddifpy(1*nx) = ddifmy(3*nx)
      ddifmy(nv)   = ddifpy((ny-2)*nx)
      ddifpy(nv)   = ddifmy((ny-2)*nx)
      meanmy(1*nx) = meanpy(3*nx)
      meanpy(1*nx) = meanmy(3*nx)
      meanmy(nv)   = meanpy((ny-2)*nx)
      meanpy(nv)   = meanmy((ny-2)*nx)
c
      do 510 iy = 1,ny
	  ya(iy)    = y(iy*nx)
	  dya(iy)   = dify(iy*nx)
	  ddya(iy)  = ddify(iy*nx)
	  ddpya(iy) = ddifpy(iy*nx)
	  ddmya(iy) = ddifmy(iy*nx)
	  mpya(iy)  = meanpy(iy*nx)
	  mmya(iy)  = meanmy(iy*nx)
  510 continue

      do 550 ix = 1,nx-1
	do 550 iy = 1,ny
	  iv = ix + (iy-1)*nx
	  y(iv)      = y(iy*nx)
	  dify(iv)   = dify(iy*nx)
	  ddify(iv)  = ddify(iy*nx)
	  ddifpy(iv) = ddifpy(iy*nx)
	  ddifmy(iv) = ddifmy(iy*nx)
	  meanpy(iv) = meanpy(iy*nx)
	  meanmy(iv) = meanmy(iy*nx)
  550 continue

      if (zentr(2))   then
	do 560 iy = 1,ny
	do 560 ix = 1,nx
	  iv  = ix+(iy-1)*nx
	  ivs = ix+nv-iy*nx
	  if ( meanpy(iv) .ne. meanmy(ivs) )
     +      write(22,31) ix,iy,meanpy(iv),meanmy(ivs),zeit
	  if ( ddifpy(iv) .ne. ddifmy(ivs) )
     +      write(22,32) ix,iy,ddifpy(iv),ddifmy(ivs),zeit
  560   continue
      end if
   31 format(' meanpy(',i3,',',i3,') =',f12.7,
     +       '   und',f12.7,'   time =',f9.4)
   32 format(' ddifpy(',i3,',',i3,') =',f12.7,
     +       '   und',f12.7,'   time =',f9.4)


c
      return
      end
	subroutine anfang
c
	include 'hinclude.f'
c
	integer  iv
	real     p0,gaminv,psirad,phirad,pp,px0,pepsy,pdelx,shoot,
     +           coef1,coef2,coef3,sinpsi,cospsi,llx,lly,b11
c ...................................................
c  equilibrium
c ...................................................

     
c for pressure pulse:  
      gaminv = 1./gamma
      phirad = 2.*pi*phi/360.
      psirad = 2.*pi*psi/360.
      if (phi .gt. 0.01) then
       delbz = 0.5*sqrt( 1.+bmsh**2-2.*bmsh*cos(phirad) )
       by0   = 0.5*bmsh*sin(phirad)/delbz
       bz0   = 0.25*(1. - bmsh**2)/delbz
      else
       kappa = 0.0
       delbz = 0.5*(1.0-bmsh)
       by0   = 0.0
       bz0   = 0.5*(1.0+bmsh)
      endif
c no rotation:
      kappa = 0.0
      delbz = 1.0
      by0   = 0.0
      bz0   = 0.0
      write(*,*) 'delbz:',delbz,'  by0',by0,'  bz0',bz0
      p0     = pmsp
      bzmsp  = bz0 + delbz
      bzmsh  = bz0 - delbz
      pmsh   = pmsp + 1.0 -bmsh**2
      betasp = pmsp
      betash = (pmsp+1.0-bmsh**2)/bmsh**2
      vamsp  = sqrt( 1.0/rho0 )
      vamsh  = sqrt( 1.0/rho0 )
      csmsp  = sqrt( gamma/2.0*pmsp/rho0 )
      csmsh  = sqrt( gamma/2.0*(pmsp+1.0-bmsh**2)/(rho0+delrho) )
      if (bz0 .lt. 0.001) then bz0=0.0

      do 30 iv = 1,nx
         help(iv)=tanh(x(iv))
   30 continue
         
      do 80 iv = 1,nx
         hilfx(iv) = help(iv)*help(iv)
         hilfy(iv) = p0 + (1.0-hilfx(iv))
         uprof(iv)   = (0.5*hilfy(iv))**gaminv
         rhoprof(iv) = 1.0
c         write(*,*) 'p:',x(iv),hilfy(iv),help(iv)*help(iv)+hilfy(iv)
   80 continue
      do 90 ix = 1,nx
       do 90 iy = 1,ny
         iv=(iy-1)*nx+ix
         hilfx(iv) = hilfx(ix) 
         u(iv)=uprof(ix)
         rho(iv)=rhoprof(ix)
   90 continue
         
      do 100 iv = 1,nv
	 bx(iv) = 0.0 
	 by(iv) = tanh(x(iv))
	 bz(iv)  = 0.0
	 sx(iv)  = 0.0
	 sy(iv)  = v0*rho(iv)*tanh(x(iv))
c	 sy(iv)  = 0.0
c	 sz(iv)  = 0.0
	 sz(iv)  = v1*rho(iv)*tanh(x(iv))
  100 continue
      llx=1.
      lly=2.	
      write(*,*) llx,lly,v1
      b11=0.4
      do 110 iv = 1,nv
	 bx(iv) = bx(iv) 
     +            + 2.*b11/lly/cosh(x(iv)/llx)**2
     +              *tanh(y(iv)/lly)/cosh(y(iv)/lly)**2
c     +               v1*pi/ymax*cos(pi*x(iv)/2./xmax)
c     +                              *cos(pi*y(iv)/ymax)
	 by(iv) = by(iv) 
     +            - 2.*b11/llx*tanh(x(iv)/llx)/cosh(x(iv)/llx)**2
     +                 /cosh(y(iv)/lly)**2
c     +               v1*pi/2./xmax*sin(pi*x(iv)/2./xmax)
c     +                 *sin(pi*y(iv)/ymax)
	 prof(iv)  = 1./cosh(2.*x(iv))/cosh(y(iv)/1.0)
  110 continue
      
      sinpsi=sin(psirad)
      cospsi=cos(psirad)
c
      do 180 iv = 2*nx+1,3*nx
         write(*,*) 'by**2+p:',by(iv),by(iv)**2+2.*u(iv)**gamma
  180 continue
      do 150 iv = 1,nv
	    res(iv) = 0.0*prof(iv)
c	    help(iv)  = 1./cosh(x(iv))
	    hilfx(iv) = 1.
	    hilfy(iv) = 1.
	    hilfz(iv) = 1.
	    feldx(iv) = 1.
	    feldy(iv) = 1.
	    feldz(iv) = 1.
  150 continue
      rhobd(1) = rho(2*nx+2)
      pbd(1)   = 2.*u(2*nx+2)**gamma
      vxbd(1)  = sx(2*nx+2)/rho(2*nx+2)
      vybd(1)  = sy(2*nx+2)/rho(2*nx+2)
      vzbd(1)  = sz(2*nx+2)/rho(2*nx+2)
      bxbd(1)  = bx(2*nx+2)
      bybd(1)  = by(2*nx+2)
      bzbd(1)  = bz(2*nx+2)
      rhobd(2) = rho(3*nx-1)
      pbd(2)   = 2.*u(3*nx-1)**gamma
      vxbd(2)  = sx(3*nx-1)/rho(3*nx-1)
      vybd(2)  = sy(3*nx-1)/rho(3*nx-1)
      vzbd(2)  = sz(3*nx-1)/rho(3*nx-1)
      bxbd(2)  = bx(3*nx-1)
      bybd(2)  = by(3*nx-1)
      bzbd(2)  = bz(3*nx-1)
c   normaliszation of simulation, nsim, bsim, lsim from parlist
c                              in cm**(-3), nT, and km
c   vsim, psim, tsim in km/s, nPascal, and s
      vsim = 21.8*bsim/sqrt(nsim)
      psim = 0.01*bsim**2/8.0/pi
      tsim = lsim/vsim
c test asy   
      iserror=0
      write(*,212)  rhobd(1),pbd(1),vxbd(1),vybd(1),vzbd(1),
     +                bxbd(1),bybd(1),bzbd(1),
     +                rhobd(2),pbd(2),vxbd(2),vybd(2),vzbd(2),
     +                bxbd(2),bybd(2),bzbd(2)
  212 format(/1x,'Initial asymptotic values at xmin (1. row) ',
     +           'and xmax (2. row) for: ',
     +       /1x,'    rho      p        vx       vy       vz    ',
     +           '   bx       by       bz    ',
     +       /,8f9.3/,8f9.3)
      write(*,*) 'psi:',psi
      write(*,*) 'MSP: v*k,va*k,cs:',vybd(1),bybd(1)/sqrt(rhobd(1)),
     +            sqrt(0.5*gamma*pbd(1)/rhobd(1))
      write(*,*) 'MSH: v*k,va*k,cs:',vybd(2),bybd(2)/sqrt(rhobd(2)),
     +            sqrt(0.5*gamma*pbd(2)/rhobd(2))
c
      return
      end
      subroutine stuff
c
      include 'hinclude.f'
      character*8      magtapn
      logical     bztt,vztt
c
 
      vztt=.false.
      bztt=.false.
      do 100 iv = 1,nv
         if (sz(iv).ne.0.0) vztt=.true.
         if (bz(iv).ne.0.0) bztt=.true.
  100 continue
      if (vztt) write (*,*) 'sz nonzero'
      if (bztt) write (*,*) 'bz nonzero'
      if (vztt .or. bztt) stop
   60 format(i5,8e11.3)

      return
      end
	subroutine glatt
c
	include 'hinclude.f'
c
	integer  iv
	real     cc
c ................................................................
      cc = 1.0/xmax/xmax
      do 100 iv = nx+2,nv-nx-1
	  help(iv) =  ( 1.-0.5/(1.+cc*x(iv)*x(iv)) )*rho(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +             *( (meanpx(iv)*rho(iv+1) + meanmx(iv)*rho(iv-1))
     +               + (meanpy(iv)*rho(iv+nx) + meanmy(iv)*rho(iv-nx)) )
  100 continue
      do 101 iv = nx+2,nv-nx-1
	    rho(iv) = help(iv)
  101 continue
c
      do 200 iv = nx+2,nv-nx-1
	  help(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*u(iv)
     +           + 0.25/(1.+cc*x(iv)*x(iv))
     +             *( (meanpx(iv)*u(iv+1) + meanmx(iv)*u(iv-1))
     +              + (meanpy(iv)*u(iv+nx) + meanmy(iv)*u(iv-nx)) )
  200 continue
      do 201 iv = nx+2,nv-nx-1
	    u(iv) = help(iv)
  201 continue
c
      do 300 iv = nx+2,nv-nx-1
	  feldx(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*sx(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*sx(iv+1) + meanmx(iv)*sx(iv-1))
     +               + (meanpy(iv)*sx(iv+nx) + meanmy(iv)*sx(iv-nx)) )
	  feldy(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*sy(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*sy(iv+1) + meanmx(iv)*sy(iv-1))
     +               + (meanpy(iv)*sy(iv+nx) + meanmy(iv)*sy(iv-nx)) )
	  feldz(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*sz(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*sz(iv+1) + meanmx(iv)*sz(iv-1))
     +               + (meanpy(iv)*sz(iv+nx) + meanmy(iv)*sz(iv-nx)) )
  300 continue
      do 301 iv = nx+2,nv-nx-1
	    sx(iv) = feldx(iv)
	    sy(iv) = feldy(iv)
	    sz(iv) = feldz(iv)
  301 continue
c
      do 400 iv = nx+2,nv-nx-1
	  feldx(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*bx(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*bx(iv+1) + meanmx(iv)*bx(iv-1))
     +               + (meanpy(iv)*bx(iv+nx) + meanmy(iv)*bx(iv-nx)) )
	  feldy(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*by(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*by(iv+1) + meanmx(iv)*by(iv-1))
     +               + (meanpy(iv)*by(iv+nx) + meanmy(iv)*by(iv-nx)) )
	  feldz(iv) =  (1.-0.5/(1.+cc*x(iv)*x(iv)))*bz(iv)
     +            + 0.25/(1.+cc*x(iv)*x(iv))
     +              *( (meanpx(iv)*bz(iv+1) + meanmx(iv)*bz(iv-1))
     +               + (meanpy(iv)*bz(iv+nx) + meanmy(iv)*bz(iv-nx)) )
  400 continue
      do 401 iv = nx+2,nv-nx-1
	    bx(iv) = feldx(iv)
	    by(iv) = feldy(iv)
	    bz(iv) = feldz(iv)
  401 continue
c
c
      return
      end
	subroutine meanlax
c
	include 'hinclude.f'
c
	integer  iv
c .................................................................
c  berechnung der fuer die lax integration notwendigen mittelwerte
c         auf dem entsprechenden gitter
c .................................................................

      do 11 iv = nx+3,nv-nx-1,2
        rho(iv)  = 0.5*( ( meanpx(iv)*rho(iv+1) 
     +                    + meanmx(iv)*rho(iv-1) )
     +                 + ( meanpy(iv)*rho(iv+nx)
     +                    + meanmy(iv)*rho(iv-nx) ) )
        u(iv)  = 0.5*( ( meanpx(iv)*u(iv+1) 
     +                    + meanmx(iv)*u(iv-1) )
     +                 + ( meanpy(iv)*u(iv+nx)
     +                    + meanmy(iv)*u(iv-nx) ) )
        bx(iv)  = 0.5*( ( meanpx(iv)*bx(iv+1) 
     +                    + meanmx(iv)*bx(iv-1) )
     +                 + ( meanpy(iv)*bx(iv+nx)
     +                    + meanmy(iv)*bx(iv-nx) ) )
        by(iv)  = 0.5*( ( meanpx(iv)*by(iv+1) 
     +                    + meanmx(iv)*by(iv-1) )
     +                 + ( meanpy(iv)*by(iv+nx)
     +                    + meanmy(iv)*by(iv-nx) ) )
        bz(iv)  = 0.5*( ( meanpx(iv)*bz(iv+1) 
     +                    + meanmx(iv)*bz(iv-1) )
     +                 + ( meanpy(iv)*bz(iv+nx)
     +                    + meanmy(iv)*bz(iv-nx) ) )
        sx(iv)  = 0.5*( ( meanpx(iv)*sx(iv+1) 
     +                    + meanmx(iv)*sx(iv-1) )
     +                 + ( meanpy(iv)*sx(iv+nx)
     +                    + meanmy(iv)*sx(iv-nx) ) )
        sy(iv)  = 0.5*( ( meanpx(iv)*sy(iv+1) 
     +                    + meanmx(iv)*sy(iv-1) )
     +                 + ( meanpy(iv)*sy(iv+nx)
     +                    + meanmy(iv)*sy(iv-nx) ) )
        sz(iv)  = 0.5*( ( meanpx(iv)*sz(iv+1) 
     +                    + meanmx(iv)*sz(iv-1) )
     +                 + ( meanpy(iv)*sz(iv+nx)
     +                    + meanmy(iv)*sz(iv-nx) ) )
   11 continue
c
      return
      end
	subroutine lax
c
	include 'hinclude.f'
c
	integer  iv
	real     eingam,chelp
c .........................................................
      eingam = 1.0 - gamma
c
c************************************************
c    1. integration of density
c    -------------------------
c************************************************
c
      do 100 iv = nx+3,nv-nx-1,2
	  rho(iv) = rho(iv) - dt * (
     +                    difx(iv)*(sx(iv+1)-sx(iv-1))
     +                  + dify(iv)*(sy(iv+nx)-sy(iv-nx)) )
  100 continue
c
c************************************************
c    2. integration of momentum equtions
c    ---------------------------------------
c************************************************
c
      do 220 iv = 1,nv,2
	  help(iv) = u(iv)**gamma + 0.5*(
     +               bx(iv)*bx(iv) + by(iv)*by(iv) + bz(iv)*bz(iv) )
  220 continue
c
      do 240 iv = 1,nv,2
	  hilfx(iv) = help(iv)
     +                + sx(iv)*sx(iv)/rho(iv) - bx(iv)*bx(iv)
	  hilfy(iv) = help(iv)
     +                + sy(iv)*sy(iv)/rho(iv) - by(iv)*by(iv)
	  feldx(iv) = sy(iv)*sz(iv)/rho(iv) - by(iv)*bz(iv)
	  feldy(iv) = sz(iv)*sx(iv)/rho(iv) - bz(iv)*bx(iv)
	  feldz(iv) = sx(iv)*sy(iv)/rho(iv) - bx(iv)*by(iv)
  240 continue
c
      do 260 iv = nx+3,nv-nx-1,2
	  sx(iv) = sx(iv) - dt*(
     +              difx(iv)*(hilfx(iv+1)-hilfx(iv-1))
     +            + dify(iv)*(feldz(iv+nx)-feldz(iv-nx)) )
	  sy(iv) = sy(iv) - dt*(
     +              dify(iv)*(hilfy(iv+nx)-hilfy(iv-nx))
     +            + difx(iv)*(feldz(iv+1)-feldz(iv-1)))
	  sz(iv) = sz(iv) - dt*(
     +            + difx(iv)*(feldy(iv+1)-feldy(iv-1))
     +            + dify(iv)*(feldx(iv+nx)-feldx(iv-nx)))
  260 continue
c
c************************************************
c    3.a  resistivity
c    -------------------------------
c************************************************
c
c      feld = curl b
c              
      do 310 iv = 1,nv
	  feldx(iv) =  0.
	  feldy(iv) =  0.
	  feldz(iv) =  0.
	  helf(iv) =  0.
  310 continue
      do 340 iv = nx+3,nv-nx-1,2
        if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
	  feldx(iv) =  dify(iv)*(bz(iv+nx)-bz(iv-nx))
	  feldy(iv) = - difx(iv)*(bz(iv+1)-bz(iv-1))
	  feldz(iv) =  difx(iv)*(by(iv+1)-by(iv-1))
     +                - dify(iv)*(bx(iv+nx)-bx(iv-nx))
        endif
  340 continue
      do 350 iv = nx+3,nv-nx-1,2
	  helf(iv) =  feldx(iv)*feldx(iv)
     +                     +feldy(iv)*feldy(iv)+feldz(iv)*feldz(iv) 
  350 continue
      if (etasw.ge.1)    call resist
c
c************************************************
c    3. integration of magnetic field
c    -------------------------------
c************************************************
c
c      hilf = v x b
c
c
      do 520 iv = 1,nv,2
	hilfx(iv) = ( sy(iv)*bz(iv) - sz(iv)*by(iv) )/rho(iv)
	hilfy(iv) = ( sz(iv)*bx(iv) - sx(iv)*bz(iv) )/rho(iv)
	hilfz(iv) = ( sx(iv)*by(iv) - sy(iv)*bx(iv) )/rho(iv)
  520 continue
c
c      attention: dx,dy,dz -> res
c             depends on resistivity model 
c             (change for res =res(j) !)
c
      do 560 iv = nx+3,nv-nx-1,2
	  bx(iv) = bx(iv) + dt*(
     +            dify(iv)*( hilfz(iv+nx)-hilfz(iv-nx) )
     +          - feldz(iv)*dify(iv)*( res(iv+nx)-res(iv-nx) ) ) 
	  by(iv) = by(iv) + dt*(
     +          - difx(iv)*( hilfz(iv+1)-hilfz(iv-1) )
     +          + feldz(iv)*difx(iv)*( res(iv+1)-res(iv-1) )  )
	  bz(iv) = bz(iv) + dt*(
     +            difx(iv)*( hilfy(iv+1)-hilfy(iv-1) )
     +          - dify(iv)*( hilfx(iv+nx)-hilfx(iv-nx) ) 
     +          - feldy(iv)*difx(iv)*( res(iv+1)-res(iv-1) )
     +          + feldx(iv)*dify(iv)*( res(iv+nx)-res(iv-nx) ) )
  560 continue
c
c************************************************
c    4. integration of pressure p
c    -------------------------
c************************************************
c
c      p = 2 * u**gamma
c
c
      do 820 iv = 1,nv,2
	  hilfx(iv) = u(iv)*sx(iv)/rho(iv)
	  hilfy(iv) = u(iv)*sy(iv)/rho(iv)
	  hilfz(iv) = u(iv)*sz(iv)/rho(iv)
  820 continue
c
      chelp = eingam/gamma/2.0**eingam
      do 840 iv = nx+3,nv-nx-1,2
	  u(iv) = u(iv) - dt*(
     +               difx(iv)*(hilfx(iv+1)-hilfx(iv-1))
     +             + dify(iv)*(hilfy(iv+nx)-hilfy(iv-nx))
     +             + chelp*res(iv)*helf(iv)*(
     +               ( meanpx(iv)*u(iv+1)+meanmx(iv)*u(iv-1) )
     +              +( meanpy(iv)*u(iv+nx)+meanmy(iv)*u(iv-nx) ) 
     +                           )**eingam )
  840 continue
c
c
      return
      end
	subroutine leap
c
	include 'hinclude.f'
c
	integer  iv
	real     ddt,eingam,dif0,chelp
c .........................................................
c .........................................................
      ddt = 2.*dt
      eingam = 1 - gamma
      if (zentr(1)) then
        dif0 = ddifx((nx+1)/2)
      else
        dif0 = ddifx(2)
      end if
c
c************************************************
c    1. integration of density
c    -------------------------
c************************************************
c
      do 105 iv = nx+2+igrid,nv-nx-1,2
	     hilf(iv) = difx(iv)*(sx(iv+1)-sx(iv-1))
     +                     + dify(iv)*(sy(iv+nx)-sy(iv-nx)) 
  105 continue
      if (ischritt .lt. ivisrho) then
	do 110 iv = nx+2+igrid,nv-nx-1,2
	  rho(iv) = rho(iv) - ddt*hilf(iv)
  110   continue
      else
        do 120 iv = nx+2+igrid,nv-nx-1,2
	  rho(iv) = rho(iv) - 0.5*ddt*hilf(iv)
  120   continue
      end if
c
c************************************************
c    2. integration of momentum equations
c    ---------------------------------------
c************************************************
c
      do 220 iv = 2-igrid,nv,2
	  help(iv) = u(iv)**gamma + 0.5*(
     +              + bx(iv)*bx(iv) + by(iv)*by(iv) + bz(iv)*bz(iv) )
  220 continue
c
      do 240 iv = 2-igrid,nv,2
	  hilfx(iv) = help(iv)
     +                 + sx(iv)*sx(iv)/rho(iv) - bx(iv)*bx(iv)
	  hilfy(iv) = help(iv)
     +                 + sy(iv)*sy(iv)/rho(iv) - by(iv)*by(iv)
	  feldx(iv) = sy(iv)*sz(iv)/rho(iv) - by(iv)*bz(iv)
	  feldy(iv) = sz(iv)*sx(iv)/rho(iv) - bz(iv)*bx(iv)
	  feldz(iv) = sx(iv)*sy(iv)/rho(iv) - bx(iv)*by(iv)
  240 continue
c
      do 245 iv = nx+2+igrid,nv-nx-1,2
	  hilfx(iv) =  difx(iv)*(hilfx(iv+1)-hilfx(iv-1))
     +                  + dify(iv)*(feldz(iv+nx)-feldz(iv-nx))
	  hilfy(iv) = dify(iv)*(hilfy(iv+nx)-hilfy(iv-nx))
     +                  + difx(iv)*(feldz(iv+1)-feldz(iv-1))
	  hilfz(iv) = difx(iv)*(feldy(iv+1)-feldy(iv-1))
     +                  + dify(iv)*(feldx(iv+nx)-feldx(iv-nx))
  245 continue
      do 250 iv = nx+2+igrid,nv-nx-1,2
	  sx(iv) = sx(iv) - 0.5*ddt*hilfx(iv)
	  sy(iv) = sy(iv) - 0.5*ddt*hilfy(iv)
	  sz(iv) = sz(iv) - 0.5*ddt*hilfz(iv)
  250 continue
c
c
c************************************************
c    boundary conditions for viscous smoothing
c    -------------------------------
c************************************************
      call randv
c************************************************
c    1a. integration of density with viscosity
c    -------------------------
c************************************************
      if (ischritt .ge. ivisrho) then
	do 405 iv = nx+1,nv-nx
	    feldx(iv) = (rho(iv+1)-rho(iv))*(rho(iv)-rho(iv-1))
	    feldy(iv) = (rho(iv+nx)-rho(iv))*(rho(iv)-rho(iv-nx))
  405   continue
        call bdfeld
	do 410 iv = nx+2+igrid,nv-nx-1,2
          if(  ( feldx(iv).lt.0 .and.
     +           ( feldx(iv+1).lt.0 .or. feldx(iv-1).lt.0) )
     +    .or. ( feldy(iv).lt.0 .and.
     +           ( feldy(iv+nx).lt.0 .or. feldy(iv-nx).lt.0) ) )
     +     hilf(iv) =  hilf(iv)
     +         -2./ddt*( -(visx-feldx(iv)/rho(iv)
     +                        +visy)*rho(iv)
     +      + (visx-feldx(iv)/rho(iv))
     +             *(meanpx(iv)*rho(iv+1)+meanmx(iv)*rho(iv-1))
     +      + visy*(meanpy(iv)*rho(iv+nx)+meanmy(iv)*rho(iv-nx)) )
c     +     hilf(iv) =  hilf(iv)
c     +         -2./ddt*( -(visx*ddifx(iv)/dif0+visy)*rho(iv)
c     +      + visx*ddifx(iv)/dif0
c     +            *(meanpx(iv)*rho(iv+1)+meanmx(iv)*rho(iv-1))
c     +      + visy*(meanpy(iv)*rho(iv+nx)+meanmy(iv)*rho(iv-nx)) )
  410   continue
	do 420 iv = nx+2+igrid,nv-nx-1,2
	     rho(iv) = rho(iv) - 0.5*ddt*hilf(iv)
  420   continue
      end if
c
c************************************************
c    2a. integration of momentum equations with viscosity
c    ---------------------------------------
c***********************************************************************
c
      do 430 iv = nx+1,nv-nx
	    feldx(iv) = (sx(iv+1)-sx(iv))*(sx(iv)-sx(iv-1))
	    feldy(iv) = (sx(iv+nx)-sx(iv))*(sx(iv)-sx(iv-nx))
  430 continue
      call bdfeld
      do 440 iv = nx+2+igrid,nv-nx-1,2
	if(    ( feldx(iv).lt.0 .and.
     +          ( feldx(iv+1).lt.0 .or. feldx(iv-1).lt.0) )
     +    .or. ( feldy(iv).lt.0 .and.
     +          ( feldy(iv+nx).lt.0 .or. feldy(iv-nx).lt.0) ) )
c     +   hilfx(iv) =  hilfx(iv)
c     +      -2./ddt*(  -( visx-feldx(iv)/
c     +    ( abs(sx(iv)) + abs(meanpx(iv)*sx(iv+1)+meanmx(iv)*sx(iv-1)) )
c     +                    +visy )*sx(iv)
c     +      + ( visx - feldx(iv)/( abs(sx(iv)) + 
c     +          abs(meanpx(iv)*sx(iv+1)+meanmx(iv)*sx(iv-1)) ) )
c     +            *(meanpx(iv)*sx(iv+1)+meanmx(iv)*sx(iv-1))
c     +      + visy*(meanpy(iv)*sx(iv+nx)+meanmy(iv)*sx(iv-nx)) )
     +   hilfx(iv) =  hilfx(iv)
     +        -2./ddt*(  -(visx+visy)*sx(iv)
     +      + visx*(meanpx(iv)*sx(iv+1)+meanmx(iv)*sx(iv-1))
     +      + visy*(meanpy(iv)*sx(iv+nx)+meanmy(iv)*sx(iv-nx)) )
c     +   hilfx(iv) =  hilfx(iv)
c     +        -2./ddt*(  -(visx*ddifx(iv)/dif0+visy)*sx(iv)
c     +      + visx*ddifx(iv)/dif0
c     +             *(meanpx(iv)*sx(iv+1)+meanmx(iv)*sx(iv-1))
c     +      + visy*(meanpy(iv)*sx(iv+nx)+meanmy(iv)*sx(iv-nx)) )
  440 continue
c
      do 450 iv = nx+1,nv-nx
	 feldx(iv) = (sy(iv+1)-sy(iv))*(sy(iv)-sy(iv-1))
	 feldy(iv) = (sy(iv+nx)-sy(iv))*(sy(iv)-sy(iv-nx))
  450 continue
      call bdfeld
      do 460 iv = nx+2+igrid,nv-nx-1,2
	if(    ( feldx(iv).lt.0 .and.
     +           ( feldx(iv+1).lt.0 .or. feldx(iv-1).lt.0) )
     +    .or. ( feldy(iv).lt.0 .and.
     +           ( feldy(iv+nx).lt.0 .or. feldy(iv-nx).lt.0) ) )
     +   hilfy(iv) =  hilfy(iv)
     +        -2./ddt*(  -(visx+visy)*sy(iv)
     +      + visx*(meanpx(iv)*sy(iv+1)+meanmx(iv)*sy(iv-1))
     +      + visy*(meanpy(iv)*sy(iv+nx)+meanmy(iv)*sy(iv-nx)) )
c     +   hilfy(iv) =  hilfy(iv)
c     +        -2./ddt*(  -(visx*ddifx(iv)/dif0+visy)*sy(iv)
c     +      + visx*ddifx(iv)/dif0
c     +             *(meanpx(iv)*sy(iv+1)+meanmx(iv)*sy(iv-1))
c     +      + visy*(meanpy(iv)*sy(iv+nx)+meanmy(iv)*sy(iv-nx)) )
  460 continue
c
      do 470 iv = nx+1,nv-nx
	 feldx(iv) = (sz(iv+1)-sz(iv))*(sz(iv)-sz(iv-1))
	 feldy(iv) = (sz(iv+nx)-sz(iv))*(sz(iv)-sz(iv-nx))
  470 continue
      call bdfeld
      do 480 iv = nx+2+igrid,nv-nx-1,2
	 if(   ( feldx(iv).lt.0 .and.
     +           ( feldx(iv+1).lt.0 .or. feldx(iv-1).lt.0) )
     +    .or. ( feldy(iv).lt.0 .and.
     +           ( feldy(iv+nx).lt.0 .or. feldy(iv-nx).lt.0) ) )
     +    hilfz(iv) =  hilfz(iv)
     +        -2./ddt*(  -(visx+visy)*sz(iv)
     +      + visx*(meanpx(iv)*sz(iv+1)+meanmx(iv)*sz(iv-1))
     +      + visy*(meanpy(iv)*sz(iv+nx)+meanmy(iv)*sz(iv-nx)) )
c     +    hilfz(iv) =  hilfz(iv)
c     +        -2./ddt*(  -(visx*ddifx(iv)/dif0+visy)*sz(iv)
c     +      + visx*ddifx(iv)/dif0
c     +             *(meanpx(iv)*sz(iv+1)+meanmx(iv)*sz(iv-1))
c     +      + visy*(meanpy(iv)*sz(iv+nx)+meanmy(iv)*sz(iv-nx)) )
  480 continue
      do 500 iv = nx+2+igrid,nv-nx-1,2
	  sx(iv) = sx(iv) - 0.5*ddt*hilfx(iv)
	  sy(iv) = sy(iv) - 0.5*ddt*hilfy(iv)
	  sz(iv) = sz(iv) - 0.5*ddt*hilfz(iv)
  500 continue
c
c************************************************
c    3.a resistivity
c    ----------------
c************************************************
c      feld = rot b
c      help necessary for implicite computation of b and res
c
      do 310 iv = 1,nv
	  feldx(iv) =  0.
	  feldy(iv) =  0.
	  feldz(iv) =  0.
	  helf(iv) =  0.
  310 continue
      do 340 iv = nx+2+igrid,nv-nx-1,2
        if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
	  feldx(iv) = dify(iv)*(bz(iv+nx)-bz(iv-nx))
	  feldy(iv) = - difx(iv)*(bz(iv+1)-bz(iv-1))
	  feldz(iv) = difx(iv)*(by(iv+1)-by(iv-1))
     +                - dify(iv)*(bx(iv+nx)-bx(iv-nx))
	endif
  340 continue
      do 350 iv = nx+2+igrid,nv-nx-1,2
	  helf(iv) =  feldx(iv)*feldx(iv)
     +                     +feldy(iv)*feldy(iv)+feldz(iv)*feldz(iv) 
  350 continue
      if (etasw.ge.1)   call resist 
c
c************************************************
c    3. integration of magnetic field
c    -------------------------------
c************************************************
c
c      hilf = v x b
c
      do 510 iv = 1,nv
	  hilfx(iv) = 0.
	  hilfy(iv) = 0.
	  hilfz(iv) = 0.
  510 continue
c
      do 520 iv = 2-igrid,nv,2
	  hilfx(iv) = ( sy(iv)*bz(iv) - sz(iv)*by(iv) )/rho(iv)
	  hilfy(iv) = ( sz(iv)*bx(iv) - sx(iv)*bz(iv) )/rho(iv)
	  hilfz(iv) = ( sx(iv)*by(iv) - sy(iv)*bx(iv) )/rho(iv)
  520 continue
      do 540 iv = nx+2+igrid,nv-nx-1,2
	  help(iv) = res(iv)*( ddifx(iv) + ddify(iv) )
  540 continue
c
c      attention: dx,dy,dz -> res
c             (change for res =res(j) !)
c
      do 560 iv = nx+2+igrid,nv-nx-1,2
	  bx(iv) = ( bx(iv) + ddt*(
     +           dify(iv)*( hilfz(iv+nx)-hilfz(iv-nx) )
     +         - feldz(iv)*dify(iv)*( res(iv+nx)-res(iv-nx) )     
     +         + res(iv)*(
     +            ( ddifpx(iv)*bx(iv+1)+ddifmx(iv)*bx(iv-1) )   
     +          + ( ddifpy(iv)*bx(iv+nx)+ddifmy(iv)*bx(iv-nx) ) )  
     +         - help(iv)*bx(iv)
     +               ) ) /(1 + ddt*help(iv))
	  by(iv) = ( by(iv) + ddt*(
     +         - difx(iv)*( hilfz(iv+1)-hilfz(iv-1) )
     +         + feldz(iv)*difx(iv)*( res(iv+1)-res(iv-1) )
     +         + res(iv)*(
     +            ( ddifpx(iv)*by(iv+1)+ddifmx(iv)*by(iv-1) )
     +          + ( ddifpy(iv)*by(iv+nx)+ddifmy(iv)*by(iv-nx) ) )
     +         - help(iv)*by(iv)
     +               ) ) / (1 + ddt*help(iv))
	  bz(iv) = ( bz(iv) + ddt*(
     +           difx(iv)*( hilfy(iv+1)-hilfy(iv-1) )
     +         - dify(iv)*( hilfx(iv+nx)-hilfx(iv-nx) )
     +         - feldy(iv)*difx(iv)*( res(iv+1)-res(iv-1) )
     +         + feldx(iv)*dify(iv)*( res(iv+nx)-res(iv-nx) )
     +         + res(iv)*(
     +            ( ddifpx(iv)*bz(iv+1)+ddifmx(iv)*bz(iv-1) )
     +          + ( ddifpy(iv)*bz(iv+nx)+ddifmy(iv)*bz(iv-nx) ) )
     +         - help(iv)*bz(iv)
     +               ) ) / (1 + ddt*help(iv))
  560 continue
c
c************************************************
c    4. integration of pressure
c    -------------------------
c************************************************
c
c      p = 2 * u**gamma
c
c
      do 820 iv = 2-igrid,nv,2
	 hilfx(iv) = u(iv)*sx(iv)/rho(iv)
	 hilfy(iv) = u(iv)*sy(iv)/rho(iv)
	 hilfz(iv) = u(iv)*sz(iv)/rho(iv)
  820 continue
c
      chelp = eingam/gamma/2.0**eingam
      do 840 iv = nx+2+igrid,nv-nx-1,2
	  u(iv) = u(iv) - ddt*(
     +               difx(iv)*(hilfx(iv+1)-hilfx(iv-1))
     +             + dify(iv)*(hilfy(iv+nx)-hilfy(iv-nx))
     +             + chelp*res(iv)*helf(iv)*(
     +               ( meanpx(iv)*u(iv+1)+meanmx(iv)*u(iv-1) )
     +              +( meanpy(iv)*u(iv+nx)+meanmy(iv)*u(iv-nx) ) 
     +                           )**eingam )
  840 continue
c
c
      return
      end
	subroutine bdfeld
c
	include 'hinclude.f'
c
	integer  iv
c ............................................................
c   computation of boundary values for feldx,feldy 
c       for viscous terms in leap      
c.............................................................
c
c at xmin/max:
      if ( perio(1) )  then
         do 410 iv = nx+1, nv-nx,nx
	   feldx(iv)      = feldx(iv+nx-3)
	   feldx(iv+nx-1) = feldx(iv+2)
	   feldy(iv)      = feldy(iv+nx-3)
	   feldy(iv+nx-1) = feldy(iv+2)
  410    continue
      else
         do 412 iv = nx+1, nv-nx,nx
	   feldx(iv)      = -abs(feldx(iv+2))
	   feldx(iv+nx-1) = -abs(feldx(iv+nx-3))
	   feldy(iv)      = feldy(iv+2)
	   feldy(iv+nx-1) = feldy(iv+nx-3)
  412    continue
      end if
c at ymin/max:
      if ( perio(2) )  then
         do 414 iv = 1, nx
	   feldx(iv)       = feldx(iv+nv-3*nx)
	   feldx(nv-nx+iv) = feldx(iv+2*nx)
	   feldy(iv)       = feldy(iv+nv-3*nx)
	   feldy(nv-nx+iv) = feldy(iv+2*nx)
  414    continue
      else
         do 416 iv = 1, nx
	   feldx(iv)       = feldx(iv+2*nx)
	   feldx(nv-nx+iv) = feldx(nv-3*nx+iv)
	   feldy(iv)       = feldy(iv+2*nx)
	   feldy(nv-nx+iv) = feldy(nv-3*nx+iv)
  416    continue
      end if
c
      return
      end
	subroutine randv
c
	include 'hinclude.f'
c
	integer  iv, nx1, nx2, nx3,
     +           nv1,nv2,nv3,nv4,nv5,
     +           nxhalb,nyhalb,nvhalb
c ............................................................
c   computation of boundary values for mhd fields
c             (busrho)
c       f(i+1) = c1*f(i-1) + c2*f(i-3) + perio*f(n-3)
c                + lsym*f(sym)
c.............................................................
c     description of method in 
c     subroutine rdkoef
c     (linesymmetry and periodicity from lsym and perio)
c
      nxhalb = (nx+1)/2
      nyhalb = (ny+1)/2
      nvhalb = (nv+1)/2
      nx1 = nx-1
      nx2 = nx-2
      nx3 = nx-3
      nv1 = nv-nx
      nv2 = nv-2*nx
      nv3 = nv-3*nx
      nv4 = nv-4*nx
      nv5 = nv-5*nx
c--------------------------------------
c   x = xmin
c   linesymmetry along z:
c   quantity    symmetry    realized in prog
c     dx,vx         a           a
c     dy,vy         a           a
c      vz          s-a          s
c      bx      ( a )/( s )      a
c      by      ( a )/( s )      a
c      bz      (s-a)/(a-s)      s
c  -> jx,ex    (a-s)/(s-a)      a 
c  -> jy,ey    (a-s)/(s-a)      a 
c  ->  jz      ( s )/( a )      s
c--------------------------------------
      if ( perio(1) )  then

       do 110 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 rho(iv) = rho(iv+nx3)
	 sx(iv)  = sx(iv+nx3)
	 sy(iv)  = sy(iv+nx3)
	 sz(iv)  = sz(iv+nx3)
  110  continue

      else if ( lsym(1,1) ) then

       do 120 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 rho(iv) = rho(nv1-iv+4)
	 sx(iv)  = -sx(nv1-iv+4)
	 sy(iv)  = -sy(nv1-iv+4)
	 sz(iv)  = sz(nv1-iv+4)
  120  continue
       sx(nvhalb-nxhalb+2)  = 0.0
       sy(nvhalb-nxhalb+2)  = 0.0

      else

       do 140 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 rho(iv) = crho1(1,1)*rho(iv+2) + crho2(1,1)*rho(iv+4)
	 sx(iv)  = csx1(1,1)*sx(iv+2) + csx2(1,1)*sx(iv+4)
	 sy(iv)  = csy1(1,1)*sy(iv+2) + csy2(1,1)*sy(iv+4)
c	 sz(iv)  = csz1(1,1)*sz(iv+2) + csz2(1,1)*sz(iv+4)
	 sz(iv)  = v0*rho(iv)*tanh(x(iv))
  140  continue
       if (v0 .gt. 0.00001) then
         do 145 iv = 2*nx+1-igrid*nx, nv1,2*nx
	   rho(iv) = rhobd(1) 
	   sy(iv)  = vybd(1)*rho(iv) 
	   sz(iv)  = vzbd(1)*rho(iv) 
  145    continue
       end if
c       if (mod(ischritt,10).eq. 0) 
c     + write(22,*) zeit,sx(2*nx+1),sx(2*nx+2),sx(2*nx+3),sx(2*nx+5)

       if (ksx(1,1) .eq. -1.) then
	do 141 iv = nx+2+igrid*nx, nv1,2*nx
  141     sx(iv) = 0.
       end if
       if (ksy(1,1) .eq. -1.) then
	do 142 iv = nx+2+igrid*nx, nv1,2*nx
  142     sy(iv) = 0.
       end if
       if (ksz(1,1) .eq. -1.) then
	do 143 iv = nx+2+igrid*nx, nv1,2*nx
  143     sz(iv) = 0.
       end if

      end if

c--------------------------------------
c   x = xmax
c       (linesymmetry along z)
c--------------------------------------
      if ( perio(1) )  then

       do 210 iv = 3*nx-igrid*nx, nv1,2*nx
	rho(iv) = rho(iv-nx+3)
	sx(iv)  = sx(iv-nx+3)
	sy(iv)  = sy(iv-nx+3)
	sz(iv)  = sz(iv-nx+3)
  210  continue

      else if ( lsym(2,1) )  then

       do 220 iv = 3*nx-igrid*nx, nv1,2*nx
	rho(iv) =  rho(nv-iv+nx2)
	sx(iv)  =  -sx(nv-iv+nx2)
	sy(iv)  =  -sy(nv-iv+nx2)
	sz(iv)  =  sz(nv-iv+nx2)
  220  continue
       sx(nvhalb+nxhalb-2)  = 0.0
       sy(nvhalb+nxhalb-2)  = 0.0

      else

       do 240 iv = 3*nx-igrid*nx, nv1,2*nx
	rho(iv) = crho1(2,1)*rho(iv-2) + crho2(2,1)*rho(iv-4)
	sx(iv)  = csx1(2,1)*sx(iv-2) + csx2(2,1)*sx(iv-4)
	sy(iv)  = csy1(2,1)*sy(iv-2) + csy2(2,1)*sy(iv-4)
	sz(iv)  = v0*rho(iv)*tanh(x(iv))
c	sz(iv)  = csz1(2,1)*sz(iv-2) + csz2(2,1)*sz(iv-4)
  240  continue
       if (v0 .gt. 0.00001) then
         do 245 iv = 3*nx-igrid*nx, nv1,2*nx
	  rho(iv) = rhobd(2) 
	  sy(iv)  = vybd(2)*rho(iv) 
 	  sz(iv)  = vzbd(2)*rho(iv) 
  245    continue
       end if

       if (ksx(2,1) .eq. -1.) then
	do 241 iv = 2*nx+igrid*nx, nv1,2*nx
  241     sx(iv-1) = 0.
       end if
       if (ksy(2,1) .eq. -1.) then
	do 242 iv = 2*nx+igrid*nx, nv1,2*nx
  242     sy(iv-1) = 0.
       end if
       if (ksz(2,1) .eq. -1.) then
	do 243 iv = 2*nx+igrid*nx, nv1,2*nx
  243     sz(iv-1) = 0.
       end if

      end if

c--------------------------------------
c   y = ymin
c     change with respect to 3d:  (linesymmetry here along z)
c--------------------------------------
      if ( perio(2) )  then

       do 310 iv = 1+igrid, nx, 2 
	rho(iv) = rho(iv+nv3)
	sx(iv)  = sx(iv+nv3)
	sy(iv)  = sy(iv+nv3)
	sz(iv)  = sz(iv+nv3)
  310  continue

      else if ( lsym(1,2) )  then

       do 320 iv = 1+igrid, nx, 2
	rho(iv) =  rho(3*nx+1-iv)
	sx(iv)  = -sx(3*nx+1-iv)
	sy(iv)  = -sy(3*nx+1-iv)
	sz(iv)  =  sz(3*nx+1-iv)
  320  continue
       sx(nx+nxhalb)  = 0.0
       sy(nx+nxhalb)  = 0.0

      else

       do 340 iv = 1+igrid, nx, 2
	rho(iv) = crho1(1,2)*rho(iv+2*nx)
     +                + crho2(1,2)*rho(iv+4*nx)
	sx(iv)  = csx1(1,2)*sx(iv+2*nx)+csx2(1,2)*sx(iv+4*nx)
	sy(iv)  = csy1(1,2)*sy(iv+2*nx)+csy2(1,2)*sy(iv+4*nx)
	sz(iv)  = csz1(1,2)*sz(iv+2*nx)+csz2(1,2)*sz(iv+4*nx)
  340  continue

       if (ksx(1,2) .eq. -1.) then
	do 341 iv = nx+2-igrid, 2*nx, 2
  341     sx(iv) = 0.
       end if
       if (ksy(1,2) .eq. -1.) then
	do 342 iv = nx+2-igrid, 2*nx, 2
  342     sy(iv) = 0.
       end if
       if (ksz(1,2) .eq. -1.) then
	do 343 iv = nx+2-igrid, 2*nx, 2
  343     sz(iv) = 0.
       end if

      end if

c--------------------------------------
c   y = ymax
c       (linesymmetry along z)
c--------------------------------------
      if ( perio(2) )  then

       do 410 iv = nv1+1+igrid, nv, 2
	rho(iv) = rho(iv-nv3)
	sx(iv)  = sx(iv-nv3)
	sy(iv)  = sy(iv-nv3)
	sz(iv)  = sz(iv-nv3)
  410  continue

      else if ( lsym(2,2) )  then

       do 420 iv = 1+igrid, nx, 2
	rho(nv1+iv) =  rho(nv2+1-iv)
	sx(nv1+iv)  = -sx(nv2+1-iv)
	sy(nv1+iv)  = -sy(nv2+1-iv)
	sz(nv1+iv)  =  sz(nv2+1-iv)
  420  continue
       sx(nv2+nxhalb)  = 0.0
       sy(nv2+nxhalb)  = 0.0

      else

       do 440 iv = nv1+1+igrid, nv, 2
	rho(iv) = crho1(2,2)*rho(iv-2*nx)
     +                + crho2(2,2)*rho(iv-4*nx)
	sx(iv)  = csx1(2,2)*sx(iv-2*nx)+csx2(2,2)*sx(iv-4*nx)
	sy(iv)  = csy1(2,2)*sy(iv-2*nx)+csy2(2,2)*sy(iv-4*nx)
	sz(iv)  = csz1(2,2)*sz(iv-2*nx)+csz2(2,2)*sz(iv-4*nx)
  440  continue

       if (ksx(2,2) .eq. -1.) then
	do 441 iv = nv2+2-igrid, nv1,2
  441     sx(iv) = 0.
       end if
       if (ksy(2,2) .eq. -1.) then
	do 442 iv = nv2+2-igrid, nv1,2
  442     sy(iv) = 0.
       end if
       if (ksz(2,2) .eq. -1.) then
	do 443 iv = nv2+2-igrid, nv1,2
  443     sz(iv) = 0.
       end if

      end if
c
      return
      end
	subroutine randb
c
	include 'hinclude.f'
c
	integer  iv, nx1, nx2, nx3,
     +           nv1,nv2,nv3,nv4,nv5,
     +           nxhalb,nyhalb,nvhalb
c ............................................................
c   computation of boundary values for mhd fields
c             (busrho)
c       f(i+1) = c1*f(i-1) + c2*f(i-3) + perio*f(n-3)
c                + lsym*f(sym)
c.............................................................
c     description of method in 
c     subroutine rdkoef
c     (linesymmetry and periodicity from lsym and perio)
c
      nxhalb = (nx+1)/2
      nyhalb = (ny+1)/2
      nvhalb = (nv+1)/2
      nx1 = nx-1
      nx2 = nx-2
      nx3 = nx-3
      nv1 = nv-nx
      nv2 = nv-2*nx
      nv3 = nv-3*nx
      nv4 = nv-4*nx
      nv5 = nv-5*nx
c--------------------------------------
c   x = xmin
c   linesymmetry along z:
c   quantity    symmetry    realized in prog
c     dx,vx         a           a
c     dy,vy         a           a
c      vz          s-a          s
c      bx      ( a )/( s )      a
c      by      ( a )/( s )      a
c      bz      (s-a)/(a-s)      s
c  -> jx,ex    (a-s)/(s-a)      a 
c  -> jy,ey    (a-s)/(s-a)      a 
c  ->  jz      ( s )/( a )      s
c--------------------------------------
      if ( perio(1) )  then

       do 110 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 u(iv)   = u(iv+nx3)
	 res(iv) = res(iv+nx3)
	 bx(iv)  = bx(iv+nx3)
	 by(iv)  = by(iv+nx3)
	 bz(iv)  = bz(iv+nx3)
  110  continue

      else if ( lsym(1,1) ) then

       do 120 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 u(iv)   = u(nv1-iv+4)
	 res(iv) = res(nv1-iv+4)
	 bx(iv)  = -bx(nv1-iv+4)
	 by(iv)  = -by(nv1-iv+4)
	 bz(iv)  = bz(nv1-iv+4)
  120  continue
       bx(nvhalb-nxhalb+2)  = 0.0
       by(nvhalb-nxhalb+2)  = 0.0

      else

       do 140 iv = 2*nx+1-igrid*nx, nv1,2*nx
	 u(iv)   = cu1(1,1)*u(iv+2) + cu2(1,1)*u(iv+4)
	 res(iv) = cres1(1,1)*res(iv+2) + cres2(1,1)*res(iv+4)
	 bx(iv)  = cbx1(1,1)*bx(iv+2) + cbx2(1,1)*bx(iv+4)
	 by(iv)  = cby1(1,1)*by(iv+2) + cby2(1,1)*by(iv+4)
	 bz(iv)  = cbz1(1,1)*bz(iv+2) + cbz2(1,1)*bz(iv+4)
  140  continue

       if (v0 .gt. 0.00001) then
         do 145 iv = 2*nx+1-igrid*nx, nv1,2*nx
	   u(iv) = uprof(1) 
  145    continue
       end if
       if (kbx(1,1) .eq. -1.) then
	do 146 iv = nx+2+igrid*nx, nv1,2*nx
  146     bx(iv) = 0.
       end if
       if (kby(1,1) .eq. -1.) then
	do 147 iv = nx+2+igrid*nx, nv1,2*nx
  147     by(iv) = 0.
       end if
       if (kbz(1,1) .eq. -1.) then
	do 148 iv = nx+2+igrid*nx, nv1,2*nx
  148     bz(iv) = 0.
       end if

      end if

c--------------------------------------
c   x = xmax
c       (linesymmetry along z)
c--------------------------------------
      if ( perio(1) )  then

       do 210 iv = 3*nx-igrid*nx, nv1,2*nx
	u(iv)   = u(iv-nx+3)
	res(iv) = res(iv-nx+3)
	bx(iv)  = bx(iv-nx+3)
	by(iv)  = by(iv-nx+3)
	bz(iv)  = bz(iv-nx+3)
  210  continue

      else if ( lsym(2,1) )  then

       do 220 iv = 3*nx-igrid*nx, nv1,2*nx
	u(iv)   =  u(nv-iv+nx2)
	res(iv) =  res(nv-iv+nx2)
	bx(iv)  =  -bx(nv-iv+nx2)
	by(iv)  =  -by(nv-iv+nx2)
	bz(iv)  =  bz(nv-iv+nx2)
  220  continue
       bx(nvhalb+nxhalb-2)  = 0.0
       by(nvhalb+nxhalb-2)  = 0.0

      else

       do 240 iv = 3*nx-igrid*nx, nv1,2*nx

	u(iv)   = cu1(2,1)*u(iv-2) + cu2(2,1)*u(iv-4)
	res(iv) = cres1(2,1)*res(iv-2) + cres2(2,1)*res(iv-4)
	bx(iv)  = cbx1(2,1)*bx(iv-2) + cbx2(2,1)*bx(iv-4)
	by(iv)  = cby1(2,1)*by(iv-2) + cby2(2,1)*by(iv-4)
	bz(iv)  = cbz1(2,1)*bz(iv-2) + cbz2(2,1)*bz(iv-4)
  240  continue

       if (v0 .gt. 0.00001) then
         do 245 iv = 3*nx-igrid*nx, nv1,2*nx
	  u(iv) = uprof(nx) 
  245    continue
       end if
       if (kbx(2,1) .eq. -1.) then
	do 246 iv = 2*nx+igrid*nx, nv1,2*nx
  246     bx(iv-1) = 0.
       end if
       if (kby(2,1) .eq. -1.) then
	do 247 iv = 2*nx+igrid*nx, nv1,2*nx
  247     by(iv-1) = 0.
       end if
       if (kbz(2,1) .eq. -1.) then
	do 248 iv = 2*nx+igrid*nx, nv1,2*nx
  248     bz(iv-1) = 0.
       end if


      end if

c--------------------------------------
c   y = ymin
c     change with respect to 3d:  (linesymmetry here along z)
c--------------------------------------
      if ( perio(2) )  then

       do 310 iv = 1+igrid, nx, 2 
	u(iv)   = u(iv+nv3)
	res(iv) = res(iv+nv3)
	bx(iv)  = bx(iv+nv3)
	by(iv)  = by(iv+nv3)
	bz(iv)  = bz(iv+nv3)
  310  continue

      else if ( lsym(1,2) )  then

       do 320 iv = 1+igrid, nx, 2 
	u(iv)   =  u(3*nx+1-iv)
	res(iv) =  res(3*nx+1-iv)
	bx(iv)  = -bx(3*nx+1-iv)
	by(iv)  = -by(3*nx+1-iv)
	bz(iv)  =  bz(3*nx+1-iv)
  320  continue
       bx(nx+nxhalb)  = 0.0
       by(nx+nxhalb)  = 0.0

      else

       do 340 iv = 1+igrid, nx, 2 
	u(iv)   = cu1(1,2)*u(iv+2*nx) + cu2(1,2)*u(iv+4*nx)
	res(iv)   = cres1(1,2)*res(iv+2*nx)
     +                + cres2(1,2)*res(iv+4*nx)
	bx(iv)  = cbx1(1,2)*bx(iv+2*nx)+cbx2(1,2)*bx(iv+4*nx)
	by(iv)  = cby1(1,2)*by(iv+2*nx)+cby2(1,2)*by(iv+4*nx)
	bz(iv)  = cbz1(1,2)*bz(iv+2*nx)+cbz2(1,2)*bz(iv+4*nx)
  340  continue

       if (kbx(1,2) .eq. -1.) then
	do 346 iv = nx+2-igrid, 2*nx, 2
  346     bx(iv) = 0.
       end if
       if (kby(1,2) .eq. -1.) then
	do 347 iv = nx+2-igrid, 2*nx, 2
  347     by(iv) = 0.
       end if
       if (kbz(1,2) .eq. -1.) then
	do 348 iv = nx+2-igrid, 2*nx, 2
  348     bz(iv) = 0.
       end if

      end if

c--------------------------------------
c   y = ymax
c       (linesymmetry along z)
c--------------------------------------
      if ( perio(2) )  then

       do 410 iv = nv1+1+igrid, nv, 2
	u(iv)   = u(iv-nv3)
	res(iv) = res(iv-nv3)
	bx(iv)  = bx(iv-nv3)
	by(iv)  = by(iv-nv3)
	bz(iv)  = bz(iv-nv3)
  410  continue

      else if ( lsym(2,2) )  then

       do 420 iv = 1+igrid, nx, 2
	u(nv1+iv)   =  u(nv2+1-iv)
	res(nv1+iv) =  res(nv2+1-iv)
	bx(nv1+iv)  = -bx(nv2+1-iv)
	by(nv1+iv)  = -by(nv2+1-iv)
	bz(nv1+iv)  =  bz(nv2+1-iv)
  420  continue
       bx(nv2+nxhalb)  = 0.0
       by(nv2+nxhalb)  = 0.0

      else

       do 440 iv = nv1+1+igrid, nv, 2
	u(iv)   = cu1(2,2)*u(iv-2*nx)+cu2(2,2)*u(iv-4*nx)
	res(iv) = cres1(2,2)*res(iv-2*nx)
     +                + cres2(2,2)*res(iv-4*nx)
	bx(iv)  = cbx1(2,2)*bx(iv-2*nx)+cbx2(2,2)*bx(iv-4*nx)
	by(iv)  = cby1(2,2)*by(iv-2*nx)+cby2(2,2)*by(iv-4*nx)
	bz(iv)  = cbz1(2,2)*bz(iv-2*nx)+cbz2(2,2)*bz(iv-4*nx)
  440  continue

       if (kbx(2,2) .eq. -1.) then
	do 446 iv = nv2+2-igrid, nv1,2
  446     bx(iv) = 0.
       end if
       if (kby(2,2) .eq. -1.) then
	do 447 iv = nv2+2-igrid, nv1,2
  447     by(iv) = 0.
       end if
       if (kbz(2,2) .eq. -1.) then
	do 448 iv = nv2+2-igrid, nv1,2
  448     bz(iv) = 0.
       end if

      end if

c------------------------------------------------
c  div b should be satisfied at boundaries but care
c  in sequence of asigning values to boundaries is required
c    attention for  symmetries und periodicity !!!!!
c------------------------------------------------
c
c   div b for bx 
c   x = xmin bzw xmax
c................................................
      if ( .not.
     +   (perio(1) .or. lsym(1,1) .or. (kby(1,1).eq.-1) ) )  then
       do 810 iv = 2*nx+2-igrid*nx, nv1,2*nx
	  bx(iv-1)  = bx(iv+1) + 1./difx(iv) * (
     +                + dify(iv)*(by(iv+nx)-by(iv-nx)) )
  810  continue
      end if

      if ( .not.
     +   (perio(1) .or. lsym(2,1) .or. (kby(2,1).eq.-1) ) )  then
       do 820 iv = 3*nx-1-igrid*nx, nv1,2*nx
	  bx(iv+1) = bx(iv-1) - 1./difx(iv) * (
     +                + dify(iv)*(by(iv+nx)-by(iv-nx)) )
  820  continue
      end if
c
c   div b for by 
c   y = ymin bzw ymax
c................................................
      if ( .not.
     +   (perio(2) .or. lsym(1,2) .or. (kbx(1,2).eq.-1) ) )  then
       do 830 iv = nx+1+igrid, 2*nx, 2
	  by(iv-nx) = by(iv+nx) + 1./dify(iv) * (
     +                + difx(iv)*(bx(iv+1)-bx(iv-1)) )
  830  continue
      end if

      if ( .not.
     +   (perio(2) .or. lsym(2,2) .or. (kbx(2,2).eq.-1) ) )  then
       do 840 iv = nv2+1+igrid, nv1, 2
	  by(iv+nx) = by(iv-nx) - 1./dify(iv) * (
     +                + difx(iv)*(bx(iv+1)-bx(iv-1)) )
  840  continue
      end if
c
      return
      end
	subroutine rdcoef
c
	include 'hinclude.f'
c
	integer  i,j,nx1,nx3,nv1,nv3
c ............................................................
c     rdcoef determines coefficients for the boundary condition 
c     in the following way:  
c ............................................................
c     f(n) = k*f(n-2) + alfa*f'(n-3)*del
c     with
c        del = 1/dif(n-1)
c        f'(n-2)  = dif(n-3)*[f(n-2) - f(n-4)]
c   => f(n) = ( k + alfa*dif(n-3)/dif(n-1) )*f(n-2)
c                     - alfa*dif(n-3)/dif(n-1)*f(n-4)
c   and
c      f(1) = ( k + alfa*dif(4)/dif(2) )*f(3)
c                     - alfa*dif(4)/dif(2)*f(5)
c.............................................
c
c     bedeutung der koeffizienten k , alfa
c     antisymmetry       k = -1  ,  alfa = 0
c     symmetry           k = 1   ,  alfa = 0
c     extrapolation      k = 1   ,  alfa = 1
c
c     b uses partly div b = 0 
c.............................................
c     indices refering to boundary coeficients:
c       1. index:  1=min, 2=max
c       2. index:  1=x, 2=y, 3=z
c
      nx1 = nx-1
      nx3 = nx-3
      nv1 = nv-1*nx
      nv3 = nv-3*nx
c
c..................
c     x = xmin
c..................
      crho1(1,1) = 1. + arho(1,1)*difx(4)/difx(2)
      crho2(1,1) =  - arho(1,1)*difx(4)/difx(2)
      cu1(1,1)   = 1. + au(1,1)*difx(4)/difx(2)
      cu2(1,1)   =  - au(1,1)*difx(4)/difx(2)
      cres1(1,1)   = 1. + ares(1,1)*difx(4)/difx(2)
      cres2(1,1)   =  - ares(1,1)*difx(4)/difx(2)
      cbx1(1,1)  = kbx(1,1) + abx(1,1)*difx(4)/difx(2)
      cbx2(1,1)  =  - abx(1,1)*difx(4)/difx(2)
      cby1(1,1)  = kby(1,1) + aby(1,1)*difx(4)/difx(2)
      cby2(1,1)  =  - aby(1,1)*difx(4)/difx(2)
      cbz1(1,1)  = kbz(1,1) + abz(1,1)*difx(4)/difx(2)
      cbz2(1,1)  =  - abz(1,1)*difx(4)/difx(2)
      csx1(1,1)  = ksx(1,1) + asx(1,1)*difx(4)/difx(2)
      csx2(1,1)  =  - asx(1,1)*difx(4)/difx(2)
      csy1(1,1)  = ksy(1,1) + asy(1,1)*difx(4)/difx(2)
      csy2(1,1)  =  - asy(1,1)*difx(4)/difx(2)
      csz1(1,1)  = ksz(1,1) + asz(1,1)*difx(4)/difx(2)
      csz2(1,1)  =  - asz(1,1)*difx(4)/difx(2)
c..................
c     x = xmax
c..................
      crho1(2,1) = 1. + arho(2,1)*difx(nx3)/difx(nx1)
      crho2(2,1) =  - arho(2,1)*difx(nx3)/difx(nx1)
      cu1(2,1)   = 1. + au(2,1)*difx(nx3)/difx(nx1)
      cu2(2,1)   =  - au(2,1)*difx(nx3)/difx(nx1)
      cres1(2,1)   = 1. + ares(2,1)*difx(nx3)/difx(nx1)
      cres2(2,1)   =  - ares(2,1)*difx(nx3)/difx(nx1)
      cbx1(2,1)  = kbx(2,1) + abx(2,1)*difx(nx3)/difx(nx1)
      cbx2(2,1)  =  - abx(2,1)*difx(nx3)/difx(nx1)
      cby1(2,1)  = kby(2,1) + aby(2,1)*difx(nx3)/difx(nx1)
      cby2(2,1)  =  - aby(2,1)*difx(nx3)/difx(nx1)
      cbz1(2,1)  = kbz(2,1) + abz(2,1)*difx(nx3)/difx(nx1)
      cbz2(2,1)  =  - abz(2,1)*difx(nx3)/difx(nx1)
      csx1(2,1)  = ksx(2,1) + asx(2,1)*difx(nx3)/difx(nx1)
      csx2(2,1)  =  - asx(2,1)*difx(nx3)/difx(nx1)
      csy1(2,1)  = ksy(2,1) + asy(2,1)*difx(nx3)/difx(nx1)
      csy2(2,1)  =  - asy(2,1)*difx(nx3)/difx(nx1)
      csz1(2,1)  = ksz(2,1) + asz(2,1)*difx(nx3)/difx(nx1)
      csz2(2,1)  =  - asz(2,1)*difx(nx3)/difx(nx1)
c..................
c     y = ymin
c..................
      crho1(1,2) = 1. + arho(1,2)*dify(4*nx)/dify(2*nx)
      crho2(1,2) =  - arho(1,2)*dify(4*nx)/dify(2*nx)
      cu1(1,2)   = 1. + au(1,2)*dify(4*nx)/dify(2*nx)
      cu2(1,2)   =  - au(1,2)*dify(4*nx)/dify(2*nx)
      cres1(1,2)   = 1. + ares(1,2)*dify(4*nx)/dify(2*nx)
      cres2(1,2)   =  - ares(1,2)*dify(4*nx)/dify(2*nx)
      cbx1(1,2)  = kbx(1,2) + abx(1,2)*dify(4*nx)/dify(2*nx)
      cbx2(1,2)  =  - abx(1,2)*dify(4*nx)/dify(2*nx)
      cby1(1,2)  = kby(1,2) + aby(1,2)*dify(4*nx)/dify(2*nx)
      cby2(1,2)  =  - aby(1,2)*dify(4*nx)/dify(2*nx)
      cbz1(1,2)  = kbz(1,2) + abz(1,2)*dify(4*nx)/dify(2*nx)
      cbz2(1,2)  =  - abz(1,2)*dify(4*nx)/dify(2*nx)
      csx1(1,2)  = ksx(1,2) + asx(1,2)*dify(4*nx)/dify(2*nx)
      csx2(1,2)  =  - asx(1,2)*dify(4*nx)/dify(2*nx)
      csy1(1,2)  = ksy(1,2) + asy(1,2)*dify(4*nx)/dify(2*nx)
      csy2(1,2)  =  - asy(1,2)*dify(4*nx)/dify(2*nx)
      csz1(1,2)  = ksz(1,2) + asz(1,2)*dify(4*nx)/dify(2*nx)
      csz2(1,2)  =  - asz(1,2)*dify(4*nx)/dify(2*nx)
c..................
c     y = ymax
c..................
      crho1(2,2) = 1. + arho(2,2)*dify(nv3)/dify(nv1)
      crho2(2,2) =  - arho(2,2)*dify(nv3)/dify(nv1)
      cu1(2,2)   = 1. + au(2,2)*dify(nv3)/dify(nv1)
      cu2(2,2)   =  - au(2,2)*dify(nv3)/dify(nv1)
      cres1(2,2)   = 1. + ares(2,2)*dify(nv3)/dify(nv1)
      cres2(2,2)   =  - ares(2,2)*dify(nv3)/dify(nv1)
      cbx1(2,2)  = kbx(2,2) + abx(2,2)*dify(nv3)/dify(nv1)
      cbx2(2,2)  =  - abx(2,2)*dify(nv3)/dify(nv1)
      cby1(2,2)  = kby(2,2) + aby(2,2)*dify(nv3)/dify(nv1)
      cby2(2,2)  =  - aby(2,2)*dify(nv3)/dify(nv1)
      cbz1(2,2)  = kbz(2,2) + abz(2,2)*dify(nv3)/dify(nv1)
      cbz2(2,2)  =  - abz(2,2)*dify(nv3)/dify(nv1)
      csx1(2,2)  = ksx(2,2) + asx(2,2)*dify(nv3)/dify(nv1)
      csx2(2,2)  =  - asx(2,2)*dify(nv3)/dify(nv1)
      csy1(2,2)  = ksy(2,2) + asy(2,2)*dify(nv3)/dify(nv1)
      csy2(2,2)  =  - asy(2,2)*dify(nv3)/dify(nv1)
      csz1(2,2)  = ksz(2,2) + asz(2,2)*dify(nv3)/dify(nv1)
      csz2(2,2)  =  - asz(2,2)*dify(nv3)/dify(nv1)
c
      do 10 j = 1,2
	if (perio(j)) then
	   lsym(1,j) = .false.
	   lsym(2,j) = .false.
	end if
  10  continue
c
      do 100 i = 1,2
       do 100 j = 1,2
	if ( perio(j) .or. lsym(i,j) ) then
	  crho1(i,j)  = 0.0
	  crho2(i,j)  = 0.0
	  cu1(i,j)    = 0.0
	  cu2(i,j)    = 0.0
	  cres1(i,j)  = 0.0
	  cres2(i,j)  = 0.0
	  cbx1(i,j)   = 0.0
	  cbx2(i,j)   = 0.0
	  cby1(i,j)   = 0.0
	  cby2(i,j)   = 0.0
	  cbz1(i,j)   = 0.0
	  cbz2(i,j)   = 0.0
	  csx1(i,j)   = 0.0
	  csx2(i,j)   = 0.0
	  csy1(i,j)   = 0.0
	  csy2(i,j)   = 0.0
	  csz1(i,j)   = 0.0
	  csz2(i,j)   = 0.0
	end if
  100 continue
      return
      end
	subroutine diag1
c
	include 'hinclude.f'
c
        integer  ix,iy,iv,nvp0,nxe,nve,no(ny),icsym,
     +           ivx(ny),nxl,iymin,iymax,
     +           iyxl,iaa,ibb
	real     balt,qalt,qnalt,jbar,width,baver,
     +           qnorm,dqndt,aflux,vxmax,vxmin
        real     xrev(ny),yrev(ny),bxx(ny),bzx(ny),
     +           vxx(ny),vyx(ny),vzx(ny),rhor(ny),cr(ny),
     +           xres(ny),etjr(ny),etotr(ny), 
     +           fluxr(ny), delyr(ny),delbr(ny),
     +           bydel(ny),bxrmin,bxrmax,
     +           xxl,yxl,cxl,exl,slxl,
     +           bmaxn,bminn,ymaxn,delyn,fplus,fminus
        logical  maxda,minda
c.....................................................
c   diagnostics to determine 
c   a: total mass and energy
c   b: magn. field reversal, no and position of x lines 
c   c: tearing mode growth rate
c.....................................................
c
c   a: computation of total mass and energy
c-----------------------------------------
      nxe = (nx+1)/2
      
      nvp0 = nv+1
      do 40 iv = 1,nv
c        if (u(iv).le.0.0) write(*,*) 'u(',iv,') =',u(iv)
        help(iv)  = u(iv)**gamma
	hilf(iv)  = 0.25/difx(iv)/dify(iv)
   40 continue

      do 50 iv = nx+2,nv-nx-1
        if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
          feldx(iv) =  dify(iv)*(bz(iv+nx)-bz(iv-nx))
          feldy(iv) = -difx(iv)*(bz(iv+1)-bz(iv-1))
          feldz(iv) = difx(iv)*(by(iv+1)-by(iv-1))
     +               -dify(iv)*(bx(iv+nx)-bx(iv-nx))
          hilfx(iv) = ( sx(iv)*difx(iv)*(help(iv+1)-help(iv-1))
     +                + sy(iv)*dify(iv)*(help(iv+nx)-help(iv-nx)) )
     +                             /rho(iv)
        else
	    feldx(iv) = 0.0
	    feldy(iv) = 0.0
	    feldz(iv) = 0.0
	    hilfx(iv) = 0.0
        end if
   50 continue
c
c    help = .5*pressure;  feld = current density
c
      do 100 iv = nx+2,nv-nx-1
        hilfy(iv) = ( sx(iv)*( feldy(iv)*bz(iv)-feldz(iv)*by(iv) )
     +              + sy(iv)*( feldz(iv)*bx(iv)-feldx(iv)*bz(iv) )
     +              + sz(iv)*( feldx(iv)*by(iv)-feldy(iv)*bx(iv) )
     +                            )/rho(iv)
        hilfz(iv) = res(iv)*( feldx(iv)*feldx(iv)
     +                      + feldy(iv)*feldy(iv)
     +                      + feldz(iv)*feldz(iv) )
  100 continue
c
c        hilfx = geschw. * grad (druck/2)
c        hilfy = stromd. * (geschw. x magnetfeld)
c        hilfz = res. * stomd.**2
c
      do 200 iv = 2*nx+3,nv-2*nx-2
        if(mod(iv,nx).ne.0 .and. mod(iv+1,nx).ne.0 .and.
     +     mod(iv-1,nx).ne.0 .and. mod(iv-2,nx).ne.0) then
	  mass(ldiag)  = mass(ldiag) + hilf(iv)*rho(iv)
	  enmag(ldiag) = enmag(ldiag) + 0.5*hilf(iv)
     +               *( bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) )
	  enkin(ldiag) = enkin(ldiag) + 0.5*hilf(iv)
     +               *( sx(iv)*sx(iv)+sy(iv)*sy(iv)+sz(iv)*sz(iv) ) 
     +                  /rho(iv) 
	  enthe(ldiag) = enthe(ldiag) + hilf(iv)*help(iv)
          vgradp(ldiag) = vgradp(ldiag) + hilf(iv)*hilfx(iv)
          vdjxb(ldiag)  = vdjxb(ldiag) + hilf(iv)*hilfy(iv)
          resj2(ldiag)  = resj2(ldiag) + hilf(iv)*hilfz(iv)
        end if
  200 continue
c
c   boundary contributions at ymin and ymax
c
      do 320 iv = nx+3,2*nx-2
	  mass(ldiag)  = mass(ldiag) + 0.5*( hilf(iv)*rho(iv) 
     +                           + hilf(nvp0-iv)*rho(nvp0-iv) )
	  enmag(ldiag) = enmag(ldiag) + 0.25*(
     +       hilf(iv)*( bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) )
     +     + hilf(nvp0-iv)*(bx(nvp0-iv)*bx(nvp0-iv)
     +          + by(nvp0-iv)*by(nvp0-iv)+bz(nvp0-iv)*bz(nvp0-iv) ) )
	  enkin(ldiag) = enkin(ldiag) + 0.25*(
     +           hilf(iv)*( sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +                                    + sz(iv)*sz(iv) )/rho(iv)
     +         + hilf(nvp0-iv)*(sx(nvp0-iv)*sx(nvp0-iv)
     +                      + sy(nvp0-iv)*sy(nvp0-iv)
     +                    + sz(nvp0-iv)*sz(nvp0-iv))/rho(nvp0-iv) )
	  enthe(ldiag) = enthe(ldiag) + 0.5*( hilf(iv)*help(iv) 
     +                            + hilf(nvp0-iv)*help(nvp0-iv) )
          vgradp(ldiag) = vgradp(ldiag) + 0.5*(hilf(iv)*hilfx(iv) 
     +                             + hilf(nvp0-iv)*hilfx(nvp0-iv) )
          vdjxb(ldiag)  = vdjxb(ldiag) + 0.5*(hilf(iv)*hilfy(iv) 
     +                            + hilf(nvp0-iv)*hilfy(nvp0-iv) )
          resj2(ldiag)  = resj2(ldiag) + 0.5*(hilf(iv)*hilfz(iv) 
     +                            + hilf(nvp0-iv)*hilfz(nvp0-iv) )
  320 continue
c
c   boundary contributions at xmin and xmax
c
      do 330 iv = 2*nx+2,nv-3*nx+2,nx
	  mass(ldiag)  = mass(ldiag) + 0.5*( hilf(iv)*rho(iv) 
     +                           + hilf(nvp0-iv)*rho(nvp0-iv) )
	  enmag(ldiag) = enmag(ldiag) + 0.25*(
     +       hilf(iv)*( bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) )
     +     + hilf(nvp0-iv)*(bx(nvp0-iv)*bx(nvp0-iv)
     +          + by(nvp0-iv)*by(nvp0-iv)+bz(nvp0-iv)*bz(nvp0-iv) ) )
	  enkin(ldiag) = enkin(ldiag) + 0.25*(
     +           hilf(iv)*(sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +                                   + sz(iv)*sz(iv) )/rho(iv)
     +         + hilf(nvp0-iv)*( sx(nvp0-iv)*sx(nvp0-iv)
     +                       + sy(nvp0-iv)*sy(nvp0-iv)
     +                     + sz(nvp0-iv)*sz(nvp0-iv) )/rho(nvp0-iv) )
	  enthe(ldiag) = enthe(ldiag) + 0.5*( hilf(iv)*help(iv) 
     +                            + hilf(nvp0-iv)*help(nvp0-iv) )
          vgradp(ldiag) = vgradp(ldiag) + 0.5*( hilf(iv)*hilfx(iv) 
     +                              + hilf(nvp0-iv)*hilfx(nvp0-iv) )
          vdjxb(ldiag)  = vdjxb(ldiag) + 0.5*( hilf(iv)*hilfy(iv) 
     +                             + hilf(nvp0-iv)*hilfy(nvp0-iv) )
          resj2(ldiag)  = resj2(ldiag) + 0.5*(hilf(iv)*hilfz(iv) 
     +              + hilf(nvp0-iv)*hilfz(nvp0-iv) )
  330 continue
c
c   boundary contributions at corners
c
      do 450 iv = nx+2,2*nx-1,nx-3
	  mass(ldiag)  = mass(ldiag) + 0.25*( hilf(iv)*rho(iv) 
     +                            + hilf(nvp0-iv)*rho(nvp0-iv) )
	  enmag(ldiag) = enmag(ldiag) + 0.125*(
     +       hilf(iv)*( bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) )
     +     + hilf(nvp0-iv)*(bx(nvp0-iv)*bx(nvp0-iv)
     +          + by(nvp0-iv)*by(nvp0-iv)+bz(nvp0-iv)*bz(nvp0-iv) ) )
	  enkin(ldiag) = enkin(ldiag) + 0.125*(
     +           hilf(iv)*( sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +                                    + sz(iv)*sz(iv) )/rho(iv)
     +         + hilf(nvp0-iv)*( sx(nvp0-iv)*sx(nvp0-iv)
     +                       + sy(nvp0-iv)*sy(nvp0-iv)
     +                     + sz(nvp0-iv)*sz(nvp0-iv) )/rho(nvp0-iv) )
	  enthe(ldiag) = enthe(ldiag) + 0.25*( hilf(iv)*help(iv) 
     +                             + hilf(nvp0-iv)*help(nvp0-iv) )
          vgradp(ldiag) = vgradp(ldiag) + 0.25*( hilf(iv)*hilfx(iv) 
     +                               + hilf(nvp0-iv)*hilfx(nvp0-iv) )
          vdjxb(ldiag)  = vdjxb(ldiag) + 0.25*( hilf(iv)*hilfy(iv) 
     +                              + hilf(nvp0-iv)*hilfy(nvp0-iv) )
          resj2(ldiag)  = resj2(ldiag) + 0.25*( hilf(iv)*hilfz(iv) 
     +                              + hilf(nvp0-iv)*hilfz(nvp0-iv) )
  450 continue

      ekinpu(ldiag) = -vgradp(ldiag) + vdjxb(ldiag)
      ethpu(ldiag)  =  vgradp(ldiag) + resj2(ldiag)
      ebpu(ldiag)   = -vdjxb(ldiag) - resj2(ldiag)
      if (gamma .ne. 1.0) enthe(ldiag) = enthe(ldiag)/(gamma-1)
c
c    enmag = feldenergie
c    enkin = kinetische energie
c    enthe = thermische energie
c    vgradp = v mal grad (p/2)
c    vdjxb =  v dot (v x b)
c    resj2 =  res mal j**2
c    ekinpu  = -vgradp + vdjxb
c    ethpu   =  vgradp + resj2
c    ebpu    = -vdjxb - resj2 = - e mal j
c
c  total mass below the boundary ix = nxe
c
      do 600 iv = 2*nx+3,nv-2*nx-nxe
        if(mod(iv,nx).gt.2 .and. mod(iv,nx).lt.nxe ) then
	  massu(ldiag) = massu(ldiag) + hilf(iv)*rho(iv)
        end if
  600 continue

      nve = nv-nxe+3
      do 620 iv = nx+3,2*nx-nxe
	  massu(ldiag)  = massu(ldiag) + 0.5*( hilf(iv)*rho(iv) 
     +                               + hilf(nve-iv)*rho(nve-iv) )
  620 continue
      do 630 iv = 2*nx+2,nv-3*nx+2,nx
	  massu(ldiag)  = massu(ldiag) + 0.5*( hilf(iv)*rho(iv) 
     +                           + hilf(iv-2+nxe)*rho(iv-2+nxe) )
  630 continue

      do 660 iv = 2*nx+2,nv-3*nx+2,nx
	  massu(ldiag)  = massu(ldiag) + 0.25*( hilf(iv)*rho(iv) 
     +                     + hilf(iv-2+nxe)*rho(iv-2+nxe) )
  660 continue

cc.............................................
c
c b: magn. field reversal, no and position of x lines 
c    procedure requires current sheet with reversal of by
c-------------------------------------------------------
c 1: determine position of field reversal and properties 
c    current sheet (position, normal field component, 
c    and current density)
c
      icsym=0
      if (by(nx+2).gt. 0.05 .and. by(2*nx-1).lt.-0.05) icsym=-1
      if (by(nx+2).lt.-0.05 .and. by(2*nx-1).gt. 0.05) icsym=1
      if (.not. zentr(1) .and. kby(1,1).eq.-1  
     +                      .and. by(2*nx-1).lt.-0.05) icsym=-1
      if (.not. zentr(1) .and. kby(1,1).eq.-1  
     +                      .and. by(2*nx-1).gt. 0.05) icsym=1
      if (icsym .eq. 0) goto 1600
 
      do 1010 iy = 1,ny
        no(iy) = 0
 1010 continue

      do 1100 iy = 1,ny
       do 1100 ix = 1,nx-2
        iv = ix + (iy-1)*nx
        if (icsym*by(iv).lt.0.0 .and. icsym*by(iv+1).ge. 0.0) then
          ivx(iy)=iv
          no(iy)=no(iy)+1
c          if (iy.lt. 20) then 
c          write(*,1998) iy, by(iv), by(iv+1), bx(iv), bx(iv+1)
c          end if
        end if
 1100 continue
 
 1998 format('iy=', I3, ' by(ix)=',F10.6,' by(ix+1)=',F10.6,
     +        ' bx(ix)=',F10.6,' bx(ix+1)=',F10.6)

      do 1110 iy = 1,ny
        bydel(iy)= - by(ivx(iy))/(by(ivx(iy)+1)-by(ivx(iy)))
 1110 continue
      if ((.not. perio(1) .and. .not. lsym(1,1) 
     +                    .and. kby(1,1).eq.-1)) then
       do 1105 iy = 1,ny
        ivx(iy)=2+nx*(iy-1)
        bydel(iy)=0.0
        no(iy)=1
c          if (iy.lt. 20) then 
c          write(*,1998) iy, by(ivx(iy)), by(ivx(iy)+1),
c     +                      bx(ivx(iy)), bx(ivx(iy)+1)
c          end if
 1105  continue
      endif

      iv1=ivx(ny-2)
      ivn=ivx(3)
      do 1200 iy = 1,ny
        iv0=ivx(iy)
        yrev(iy)=y(iv0)
        xrev(iy)=x(iv0) + bydel(iy)*(x(iv0+1)-x(iv0))
        bxx(iy) =bx(iv0) + bydel(iy)*(bx(iv0+1)-bx(iv0))
        bzx(iy) =bz(iv0) + bydel(iy)*(bz(iv0+1)-bz(iv0))
        rhor(iy)=rho(iv0) + bydel(iy)*(rho(iv0+1)-rho(iv0))
        vxx(iy) =sx(iv0)/rho(iv0) 
     +        + bydel(iy)*(sx(iv0+1)/rho(iv0+1) 
     +                        -sx(iv0)/rho(iv0) )
        vyx(iy) =sy(iv0)/rho(iv0) 
     +        + bydel(iy)*(sy(iv0+1)/rho(iv0+1) 
     +                        -sy(iv0)/rho(iv0) )
        vzx(iy) =sz(iv0)/rho(iv0) 
     +        + bydel(iy)*(sz(iv0+1)/rho(iv0+1) 
     +                        -sz(iv0)/rho(iv0) )
        if (iy.gt.1 .and. iy.lt.ny) 
     +    cr(iy)  =feldz(iv0) + bydel(iy)
     +                          *(feldz(iv0+1)-feldz(iv0))
c the following eval for the current is only for periodic boundaries
        if (iy.eq.1 ) 
     +    cr(iy)  =feldz(iv1) + bydel(ny-2)
     +                          *(feldz(iv1+1)-feldz(iv1))
        if (iy.eq.ny ) 
     +    cr(ny)  =feldz(ivn) + bydel(3)
     +                          *(feldz(ivn)-feldz(ivn))
        xres(iy)=res(iv0) + bydel(iy)*
     +                           (res(iv0+1)-res(iv0))
        etjr(iy)=res(iv0)*feldz(iv0)  +  bydel(iy)*
     +                      ( res(iv0+1)*feldz(iv0+1)
     +                           -res(iv0)*feldz(iv0))
        etotr(iy)=etjr(iy) + sy(iv0)*bx(iv0)/rho(iv0)
     +     +  bydel(iy)*( sy(iv0+1)*bx(iv0+1)/rho(iv0+1) 
     +                      - sy(iv0)*bx(iv0)/rho(iv0) )
c          if (zeit .gt. 9.0 .and. iy.lt. 20) then 
c          write(*,1999) iy, bydel(iy), xrev(iy), bxx(iy), cr(iy)
c          end if
 1200 continue

 1999 format('iy=',i4,'     bydel(iy)=',F10.6,' xrev=',F10.6,
     +        ' bxrev=',F10.6,' cr=',F10.6)
      if (icsym.eq.-1) then
        do 1210 iy = 1,ny-1
          bxx(iy) = -bxx(iy)
 1210   continue
      end if 

c compute the flux along the reversal region:
      fluxr(1)=0.0
      do 1300 iy = 2,ny-1
         fluxr(iy)=fluxr(iy-1) + 0.5*(yrev(iy)-yrev(iy-1))*
     +                            (bxx(iy)+bxx(iy-1))
         delyr(iy)=yrev(iy)-yrev(iy-1)
         delbr(iy)=bxx(iy)-bxx(iy-1)
 1300 continue

c compute location of x and o lines and properties:
c      write(*,*) 'In Diag1, Zeit1=', zeit

      noxl=0
      nool=0
      if (bxx(1).lt.0.0) then
       do 1400 iy = 2,ny        
        if (bxx(iy-1).lt.0.0 .and. bxx(iy).ge.0.0) then
          noxl=noxl+1
          xxl=xrev(iy-1) - ( xrev(iy)-xrev(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          yxl=yrev(iy-1) - bxx(iy-1)*delyr(iy)/delbr(iy)
          vxxl=vxx(iy-1) - ( vxx(iy)-vxx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vyxl=vyx(iy-1) - ( vyx(iy)-vyx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vzxl=vzx(iy-1) - ( vzx(iy)-vzx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          cxl=cr(iy-1) - (cr(iy)-cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          resxl=xres(iy-1)-( xres(iy)-xres(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
c          write(*,*) ' cur/res', cr(iy),cr(iy-1),xres(iy),xres(iy-1)
          exl=xres(iy-1)*cr(iy-1) 
     +        -(xres(iy)*cr(iy)-xres(iy-1)*cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          if (cr(iy-1).gt. 1.3*cr(iy)) then
            cxl=cr(iy-1)
            resxl=xres(iy-1)
            exl=cr(iy-1)*xres(iy-1)
          endif
          if (cr(iy).gt. 1.3*cr(iy-1)) then
            cxl=cr(iy)
            resxl=xres(iy)
            exl=cr(iy)*xres(iy)
          endif
c          exl=cxl*resxl
          flxl=fluxr(iy) - 0.5*delyr(iy)/delbr(iy)*bxx(iy-1)**2
          if (iy.gt.2 .and. iy.lt.ny) then
           slxl = 0.5*(xrev(iy)-xrev(iy-2)) / (yrev(iy) - yrev(iy-2))           
     +        + 0.5*(xrev(iy+1)-xrev(iy-1)) / (yrev(iy+1) - yrev(iy-1))
          else   
           slxl = (xrev(iy)-xrev(iy-1)) / (yrev(iy) - yrev(iy-1)) 
          end if 
        end if
c
        if (bxx(iy-1).ge.0.0 .and. bxx(iy).lt.0.0) then
          nool=nool+1
          xol=xrev(iy-1) - ( xrev(iy)-xrev(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          yol=yrev(iy-1) - bxx(iy-1)*delyr(iy)/delbr(iy)
          vxol=vxx(iy-1) - ( vxx(iy)-vxx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vyol=vyx(iy-1) - ( vyx(iy)-vyx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vzol=vzx(iy-1) - ( vzx(iy)-vzx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          col=cr(iy-1) - (cr(iy)-cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          resol=xres(iy-1)-( xres(iy)-xres(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          eol=xres(iy-1)*cr(iy-1) 
     +        -(xres(iy)*cr(iy)-xres(iy-1)*cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
c          exl=cxl*resxl
          flol=fluxr(iy) - 0.5*delyr(iy)/delbr(iy)*bxx(iy-1)**2
          if (iy.gt.2 .and. iy.lt.ny) then
           slol = 0.5*(xrev(iy)-xrev(iy-2)) / (yrev(iy) - yrev(iy-2))           
     +        + 0.5*(xrev(iy+1)-xrev(iy-1)) / (yrev(iy+1) - yrev(iy-1))
          else   
           slol = (xrev(iy)-xrev(iy-1)) / (yrev(iy) - yrev(iy-1)) 
          end if 
c
          if (abs(flol-flxl) .gt. 0.00001) then
            write(24,1) zeit,1,xxl,yxl,vyxl,cxl,exl,slxl,flxl,noxl
            write(24,1) zeit,0,xol,yol,vyol,col,eol,slol,flol,nool
c            write(*,1) zeit,1,xxl,yxl,vyxl,cxl,exl,slxl,flxl,noxl
c            write(*,1) zeit,0,xol,yol,vyol,col,eol,slol,flol,nool
          else
            nool=nool-1
            noxl=noxl-1
          end if
        end if
 1400  continue
c      write(*,*) 'In Diag1 - in and out of 1400, Zeit=', zeit
      end if

      if (bxx(1).gt.0.0) then
       do 1401 iy = 2,ny        
        if (bxx(iy-1).gt.0.0 .and. bxx(iy).le.0.0) then
          nool=nool+1
          xol=xrev(iy-1) - ( xrev(iy)-xrev(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          yol=yrev(iy-1) - bxx(iy-1)*delyr(iy)/delbr(iy)
          vxol=vxx(iy-1) - ( vxx(iy)-vxx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vyol=vyx(iy-1) - ( vyx(iy)-vyx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vzol=vzx(iy-1) - ( vzx(iy)-vzx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          col=cr(iy-1) - (cr(iy)-cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          resol=xres(iy-1)-( xres(iy)-xres(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          eol=xres(iy-1)*cr(iy-1) 
     +        -(xres(iy)*cr(iy)-xres(iy-1)*cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
c          exl=cxl*resxl
          flol=fluxr(iy) - 0.5*delyr(iy)/delbr(iy)*bxx(iy-1)**2
          if (iy.gt.2 .and. iy.lt.ny) then
           slol = 0.5*(xrev(iy)-xrev(iy-2)) / (yrev(iy) - yrev(iy-2))           
     +        + 0.5*(xrev(iy+1)-xrev(iy-1)) / (yrev(iy+1) - yrev(iy-1))
          else   
           slol = (xrev(iy)-xrev(iy-1)) / (yrev(iy) - yrev(iy-1)) 
          end if 
        end if
        if (bxx(iy-1).le.0.0 .and. bxx(iy).gt.0.0) then
          noxl=noxl+1
          xxl=xrev(iy-1) - ( xrev(iy)-xrev(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          yxl=yrev(iy-1) - bxx(iy-1)*delyr(iy)/delbr(iy)
          vxxl=vxx(iy-1) - ( vxx(iy)-vxx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vyxl=vyx(iy-1) - ( vyx(iy)-vyx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          vzxl=vzx(iy-1) - ( vzx(iy)-vzx(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          cxl=cr(iy-1) - (cr(iy)-cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          resxl=xres(iy-1)-( xres(iy)-xres(iy-1) )
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          exl=xres(iy-1)*cr(iy-1) 
     +        -(xres(iy)*cr(iy)-xres(iy-1)*cr(iy-1))
     +                   *bxx(iy-1)*delyr(iy)/delbr(iy)
          if (cr(iy-1).lt. 1.3*cr(iy)) then
            cxl=cr(iy-1)
            resxl=xres(iy-1)
            exl=cr(iy-1)*xres(iy-1)
          endif
          if (cr(iy).lt. 1.3*cr(iy-1)) then
            cxl=cr(iy)
            resxl=xres(iy)
            exl=cr(iy)*xres(iy)
          endif
c          exl=cxl*resxl
          flxl=fluxr(iy) - 0.5*delyr(iy)/delbr(iy)*bxx(iy-1)**2
          if (iy.gt.2 .and. iy.lt.ny) then
           slxl = 0.5*(xrev(iy)-xrev(iy-2)) / (yrev(iy) - yrev(iy-2))           
     +        + 0.5*(xrev(iy+1)-xrev(iy-1)) / (yrev(iy+1) - yrev(iy-1))
          else   
           slxl = (xrev(iy)-xrev(iy-1)) / (yrev(iy) - yrev(iy-1)) 
          end if 
          if (abs(flol-flxl) .gt. 0.00001) then
            write(24,1) zeit,0,xol,yol,vyol,col,eol,slol,flol,nool
            write(24,1) zeit,1,xxl,yxl,vyxl,cxl,exl,slxl,flxl,noxl
c            write(*,1) zeit,0,xol,yol,vyol,col,eol,slol,flol,nool
c            write(*,1) zeit,1,xxl,yxl,vyxl,cxl,exl,slxl,flxl,noxl
          else
            nool=nool-1
            noxl=noxl-1
          end if
        end if
c
 1401  continue
c      write(*,*) 'In Diag1 - in and out of 1401, Zeit=', zeit
       end if
    1 format(f6.2,i3,2f9.3,f9.4,f9.4,f9.5,f9.3,f10.6,i3)


      if ( mod(ischritt,5*idiag) .eq. 0 )  then
        write(26,4) zeit
	  iy1 = 2
	  iy2 = 10
   21   write(26,5) (xrev(iy),iy=iy1,iy2)
	  iy1 = iy1+9
	  iy2 = iy2+9
	  if(iy2.ge.ny) iy2 = ny-1
	  if(iy1.le.ny-1) goto 21
	  iy1 = 2
	  iy2 = 10
   31   write(26,5) (cr(iy),iy=iy1,iy2)
	  iy1 = iy1+9
	  iy2 = iy2+9
	  if(iy2.ge.ny) iy2 = ny-1
	  if(iy1.le.ny-1) goto 31
	  iy1 = 2
	  iy2 = 10
   41   write(26,5) (bxx(iy),iy=iy1,iy2)
	  iy1 = iy1+9
	  iy2 = iy2+9
	  if(iy2.ge.ny) iy2 = ny-1
	  if(iy1.le.ny-1) goto 41
      end if
 1600 continue       

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      iaa=(nx+1)/2
      ibb=(ny+1)/2
      vxmax=-1000.
      vxmin=1000.
      aflux=0.0
      do 597  iy=1,ny
      aflux=sx((iy-1)*nx+iaa)/rho((iy-1)*nx+iaa)
      if(aflux.gt.vxmax) vxmax=aflux
      if(aflux.lt.vxmin) vxmin=aflux
  597 continue
      vxmax=abs(vxmax-vxmin)
      aflux=0.0
      do 569  iy=ibb, ny-1
      aflux=aflux+(bx(iy*nx+iaa)+bx((iy-1)*nx+iaa))/2.0
     +            *(y(iy*nx+iaa)-y((iy-1)*nx+iaa))
  569 continue 
      write(49,*)zeit,aflux,vxmax


c.............................................
c
c   c: tearing mode growth rate
c-------------------------------
      if ((bxrmax-bxrmin) .gt. 0.00000002 .and. ischritt.gt.0) then
        talt  = tneu
        balt  = bneu
        qalt  = qneu
        qnalt = qnneu
        tneu  = zeit
        tdiff = tneu-talt
        bneu  = 0.0
        qneu  = 0.0
        qnneu = 0.0
        bneu = 0.5*(bxrmax-bxrmin)
        jbar  = 0.25/dify(2*nx)*cr(2) + 0.25/dify(nv-nx)*cr(ny-1)
        do 2000 iy = 3,ny-2
          jbar  = jbar + 0.5/dify(iy*nx)*cr(iy)
 2000   continue
        jbar = abs(jbar)/(ymax-ymin)
        if (jbar.gt.0.001) then 
          width = 1.0/jbar
        else  
          width = 0.001
        end if
      
        baver = 0.5*(balt+bneu)
        if (baver .lt. 0.0000001)  baver=0.0000001
        qneu = 1.0/baver*(bneu-balt)/tdiff
        qnneu = qneu*width**1.5
        qnorm = qneu*width
        dqndt = (qnneu-qnalt)/tdiff
c
        write(25,3) zeit,baver,width,qneu,qnneu,qnorm,dqndt
      end if

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc  This part for K-H mode's growth rate
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      icsym=0
      if (sy(nx+2).gt. 0.05 .and. sy(2*nx-1).lt.-0.05) icsym=-1
      if (sy(nx+2).lt.-0.05 .and. sy(2*nx-1).gt. 0.05) icsym=1
      if (.not. zentr(1) .and. kby(1,1).eq.-1  
     +                      .and. sy(2*nx-1).lt.-0.05) icsym=-1
      if (.not. zentr(1) .and. kby(1,1).eq.-1  
     +                      .and. sy(2*nx-1).gt. 0.05) icsym=1
      if (icsym .eq. 0) goto 3300
 
      do 2010 iy = 1,ny
        no(iy) = 0
 2010 continue
c      write(*,*) 'Zeit=', zeit
      do 2100 iy = 1,ny-1
       do 2100 ix = 1,nx-2
        iv = ix + (iy-1)*nx
        if (icsym*sy(iv).lt.0.0 .and. icsym*sy(iv+1).ge. 0.0) then
          ivx(iy)=iv
          no(iy)=no(iy)+1
          if (iy.lt. 20) then 
c          write(*,*) iy, sy(iv), sy(iv+1), sx(iv), sx(iv+1)
          end if
        end if
 2100 continue
      do 2110 iy = 1,ny-1
        bydel(iy)= - (sy(ivx(iy))/rho(ivx(iy)))/(sy(ivx(iy)+1)
     +          /rho(ivx(iy)+1)-sy(ivx(iy))/rho(ivx(iy)))
 2110 continue
      do 2200 iy = 1,ny-1
        xrev(iy)=x(ivx(iy)) + bydel(iy)*(x(ivx(iy)+1)-x(ivx(iy)))
        bxx(iy) =sx(ivx(iy))/rho(ivx(iy)) + bydel(iy)*
     +         (sx(ivx(iy)+1)/rho(ivx(iy)+1)-sx(ivx(iy))/rho(ivx(iy)))
        cr(iy)  =feldz(ivx(iy)) + bydel(iy)
     +                          *(feldz(ivx(iy)+1)-feldz(ivx(iy)))
        xres(iy)=res(ivx(iy)) + bydel(iy)*
     +                           (res(ivx(iy)+1)-res(ivx(iy)))
          if (iy.lt. 20) then 
c          write(*,2999) bydel(iy), xrev(iy), bxx(iy), cr(iy)
          end if
 2200 continue
 2999 format('     bydel(iy)=',F10.6,' xrev=',F10.6,
     +        ' bxrev=',F10.6,' cr=',F10.6)

      if (icsym.eq.-1) then
        do 2210 iy = 1,ny-1
          bxx(iy) = -bxx(iy)
 2210   continue
      end if 
         
        bxrmin=1.0
        nol=0
        do 2300 iy = 2,ny-1
          if (bxx(iy).lt.bxrmin) then
            iymin=iy
            bxrmin=bxx(iy)
          endif
 2300   continue
c
      bxrmax=-1.0
      do 2400 iy = 2,ny-1
        if (bxx(iy).gt.bxrmax) then
          iymax=iy
          ymaxn=ya(iy)
          bxrmax=bxx(iy)
        end if
 2400 continue

 3300 continue

      if ((bxrmax-bxrmin) .gt. 0.00000002 .and. ischritt.gt.0) then
        talt  =tnew 
        balt  =vnew
        qalt  =qknew
        qnalt =qkknew 
        tnew  =zeit
        tdiff =tnew-talt
         vnew = 0.0
         qknew = 0.0
         qkknew= 0.0
         vnew= 0.5*(bxrmax-bxrmin)
        jbar  = 0.25/dify(2*nx)*cr(2) + 0.25/dify(nv-nx)*cr(ny-1)
        do 3000 iy = 3,ny-2
          jbar  = jbar + 0.5/dify(iy*nx)*cr(iy)
 3000   continue
        jbar = abs(jbar)/(ymax-ymin)
        if (jbar.gt.0.001) then 
          width = 1.0/jbar
        else  
          width = 0.001
        end if
      
        baver = 0.5*(balt+vnew)
        if (baver .lt. 0.0000001)  baver=0.0000001
        qknew = 1.0/baver*(vnew-balt)/tdiff
        qkknew=qknew*width**1.5
        qnorm =qknew*width
        dqndt = (qkknew-qnalt)/tdiff
 
       write(38,3) zeit,baver,width,qknew,qkknew,qnorm,dqndt
      end if

    3 format(2x,f8.3,f11.6,f11.3,f11.5,f11.5,f11.5,f11.6)
    4 format(2x,f9.4)
    5 format(9(f8.3))
c
      return
      end
	subroutine diag2
c
	include 'hinclude.f'
c
        integer  iv
c	real     dvol
c.....................................................
c   bestimmung des flusses von masse, energien und feld durch eine 
c            ebene x = const (hier x=0)
c.....................................................
      if (zentr(1)) then
        nxe = (nx+1)/2
      else
        nxe = 2
      end if

      nvp0 = nv+1

      do 40 iv = nxe,nv-nx+nxe,nx
	hilf(iv)  = 0.5/dify(iv)
        help(iv)  = u(iv)**gamma
	hilfx(iv) = sx(iv)/rho(iv)
	hilfy(iv) = 0.5*( sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +                                  + sz(iv)*sz(iv) )/rho(iv)
   40 continue

      do 50 iv = nx+nxe,nv-2*nx+nxe,nx
          feldx(iv) =  hilfx(iv)
     +         *( bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) )
     +     - bx(iv)/rho(iv)*( sx(iv)*bx(iv)
     +                      + sy(iv)*by(iv) + sz(iv)*bz(iv) )
          feldy(iv) = -difx(iv)*(bz(iv+1)-bz(iv-1))
          feldz(iv) =  difx(iv)*(by(iv+1)-by(iv-1))
     +                  -dify(iv)*(bx(iv+nx)-bx(iv-nx))
   50 continue
c
      do 100 iv = nx+nxe,nv-2*nx+nxe,nx
        hilfz(iv) =  res(iv)*( feldy(iv)*bz(iv)-feldz(iv)*by(iv) )
  100 continue
c
c        hilf  = dely*delz
c        help  = druck/2
c        hilfx = vx
c        hilfy = 0.5*rho*v**2
c        hilfz = res*(strom x b)_xcomp 
c        feldx = -(v x b) x b 
c        feldx+hilfz = (e x b)_xcomp 
c        feldy = stromy 
c        feldz = stromz 
c
      do 200 iv = 2*nx+nxe,nv-3*nx+nxe,nx
	frho(ldiag)  = frho(ldiag)  - hilf(iv)*sx(iv)
	fethe(ldiag) = fethe(ldiag) - hilf(iv)*hilfx(iv)*help(iv)
	fekin(ldiag) = fekin(ldiag) - hilf(iv)*hilfx(iv)*hilfy(iv)
	febi(ldiag)  = febi(ldiag)  - hilf(iv)*feldx(iv)
	febr(ldiag)  = febr(ldiag)  - hilf(iv)*hilfz(iv)
	fphi(ldiag)  = fphi(ldiag)  - hilf(iv)*bx(iv)
  200 continue

      do 310 iv = nx+nxe,nv-2*nx+nxe,nv-3*nx
	frho(ldiag)  = frho(ldiag)  - 0.5*hilf(iv)*sx(iv)
	fethe(ldiag) = fethe(ldiag) - 0.5*hilf(iv)*hilfx(iv)*help(iv)
	fekin(ldiag) = fekin(ldiag) - 0.5*hilf(iv)*hilfx(iv)*hilfy(iv)
	febi(ldiag)  = febi(ldiag)  - 0.5*hilf(iv)*feldx(iv)
	febr(ldiag)  = febr(ldiag)  - 0.5*hilf(iv)*hilfz(iv)
	fphi(ldiag)  = fphi(ldiag)  - 0.5*hilf(iv)*bx(iv)
  310 continue

        fphipi(ldiag) = ( sx(nx+nxe)*by(nx+nxe) 
     +                  - sy(nx+nxe)*bx(nx+nxe) )/rho(nx+nxe)
     +        - ( sx(nv-2*nx+nxe)*by(nv-2*nx+nxe) 
     +          - sy(nv-2*nx+nxe)*bx(nv-2*nx+nxe) )/rho(nv-2*nx+nxe)
        fphipr(ldiag) =  - res(nx+nxe)*feldz(nx+nxe)
     +                   + res(nv-2*nx+nxe)*feldz(nv-2*nx+nxe) 

      feb(ldiag) = febi(ldiag) + febr(ldiag) 
      fphip(ldiag) = fphipi(ldiag) + fphipr(ldiag)
      if (gamma .ne. 1.0) fethe(ldiag) = fethe(ldiag)*gamma/(gamma-1)

c
c alle groesse bez. fluss in negative x richtung durch x = 0
c
c    frho = massefluss
c    fekin = fluss kinetischer energie
c    fethe = fluss thermischer energie
c    feb = fluss von feldenergie
c      index: i-ideale beitraege, r-resistive beitraege
c    fphi = fluss des magnetfeldes
c    fphip = flussaenderung des magnetfeldes
c      index: i-ideale beitraege, r-resistive beitraege
c
      return
      end
	subroutine diag3
c
	include 'hinclude.f'
c
        integer  iv,ivp,ivbp,ivbm
	real     pmax,bnp,bnm,
     +           xp,yp,xbp,ybp,xbm,ybm,
     +           dxp,dxm,dfpx,dfmx,dyp,dym,dfpy,dfmy,
     +           hnenx,hneny,alphx,alphy,betax,betay,
     +           delx,dely
c.....................................................
c   fte properties
c.....................................................

      pmax = 1.0 + pmsp + 0.01
      xp = 0.0
      yp = 0.0
      ivp = 1
      bnp = 0.001
      xbp = 0.0
      ybp = 0.0
      ivbp = 1
      bnm = -0.001
      xbm = 0.0
      ybm = 0.0
      ivbm = 1

      do 40 iv = nx+2, nv-nx-1
        help(iv)  =  2.0*u(iv)**gamma
     +             + bx(iv)*bx(iv)+by(iv)*by(iv)+bz(iv)*bz(iv) 
   40 continue

      do 100 iv = nx+3,nv-2*nx-2
        if(mod(iv,nx).gt.2 .and. mod(iv,nx).lt.nx-1 
     +                     .and. help(iv) .gt. pmax) then
          pmax = help(iv)
          ivp = iv
        end if
  100 continue

      do 110 iv = nx+3,nv-2*nx-2
        if(mod(iv,nx).gt.2 .and. mod(iv,nx).lt.nx-1 
     +                     .and. bx(iv) .gt. bnp) then
          bnp = bx(iv)
          ivbp = iv
        end if
  110 continue

      do 120 iv = nx+3,nv-2*nx-2
        if(mod(iv,nx).gt.2 .and. mod(iv,nx).lt.nx-1 
     +                     .and. bx(iv) .lt. bnm) then
          bnm = bx(iv)
          ivbm = iv
        end if
  120 continue

      dxp  = x(ivp+1)-x(ivp)
      dxm  = x(ivp)-x(ivp-1)
      dfpx = help(ivp+1)-help(ivp)
      dfmx = help(ivp-1)-help(ivp)
      dyp  = y(ivp+nx)-y(ivp)
      dym  = y(ivp)-y(ivp-nx)
      dfpy = help(ivp+nx)-help(ivp)
      dfmy = help(ivp-nx)-help(ivp)
      hnenx = dxp*dxm*(dxp+dxm)
      hneny = dyp*dym*(dyp+dym)
      alphx = (dfpx*dxm+dfmx*dxp)/hnenx
      alphy = (dfpy*dym+dfmy*dyp)/hneny
      betax = (dfpx*dxm*dxm-dfmx*dxp*dxp)/hnenx
      betay = (dfpy*dym*dym-dfmy*dyp*dyp)/hneny
      if (alphx.ne.0) then
          delx = -0.5*betax/alphx
      else 
          delx = 0.0
      end if
      if (alphy.ne.0) then
          dely = -0.5*betay/alphy
      else 
          dely = 0.0
      end if
      xp = x(ivp) + delx
      yp = y(ivp) + dely
      pmax = pmax + alphx*delx*delx + betax*delx
     +            + alphy*dely*dely + betay*dely

      dxp  = x(ivbp+1)-x(ivbp)
      dxm  = x(ivbp)-x(ivbp-1)
      dfpx = bx(ivbp+1)-bx(ivbp)
      dfmx = bx(ivbp-1)-bx(ivbp)
      dyp  = y(ivbp+nx)-y(ivbp)
      dym  = y(ivbp)-y(ivbp-nx)
      dfpy = bx(ivbp+nx)-bx(ivbp)
      dfmy = bx(ivbp-nx)-bx(ivbp)
      hnenx = dxp*dxm*(dxp+dxm)
      hneny = dyp*dym*(dyp+dym)
      alphx = (dfpx*dxm+dfmx*dxp)/hnenx
      alphy = (dfpy*dym+dfmy*dyp)/hneny
      betax = (dfpx*dxm*dxm-dfmx*dxp*dxp)/hnenx
      betay = (dfpy*dym*dym-dfmy*dyp*dyp)/hneny
      if (alphx.ne.0) then
          delx = -0.5*betax/alphx
      else 
          delx = 0.0
      end if
      if (alphy.ne.0) then
          dely = -0.5*betay/alphy
      else 
          dely = 0.0
      end if
      xbp = x(ivbp) + delx
      ybp = y(ivbp) + dely
      bnp = bnp + alphx*delx*delx + betax*delx
     +                      + alphy*dely*dely + betay*dely


      dxp  = x(ivbm+1)-x(ivbm)
      dxm  = x(ivbm)-x(ivbm-1)
      dfpx = bx(ivbm+1)-bx(ivbm)
      dfmx = bx(ivbm-1)-bx(ivbm)
      dyp  = y(ivbm+nx)-y(ivbm)
      dym  = y(ivbm)-y(ivbm-nx)
      dfpy = bx(ivbm+nx)-bx(ivbm)
      dfmy = bx(ivbm-nx)-bx(ivbm)
      hnenx = dxp*dxm*(dxp+dxm)
      hneny = dyp*dym*(dyp+dym)
      alphx = (dfpx*dxm+dfmx*dxp)/hnenx
      alphy = (dfpy*dym+dfmy*dyp)/hneny
      betax = (dfpx*dxm*dxm-dfmx*dxp*dxp)/hnenx
      betay = (dfpy*dym*dym-dfmy*dyp*dyp)/hneny
      if (alphx.ne.0) then
          delx = -0.5*betax/alphx
      else 
          delx = 0.0
      end if
      if (alphy.ne.0) then
          dely = -0.5*betay/alphy
      else 
          dely = 0.0
      end if
      xbm = x(ivbm) + delx
      ybm = y(ivbm) + dely
      bnm = bnm + alphx*delx*delx + betax*delx
     +                      + alphy*dely*dely + betay*dely

      vx = sx(ivp)/rho(ivp)
      vy = sy(ivp)/rho(ivp)
      vz = sz(ivp)/rho(ivp)
      delb = bnp-bnm
      delx = xbp-xbm
      dely = ybp-ybm

      if(mod(ivp,nx).le.3 .or. mod(ivp,nx).ge.nx-3 
     +       .or. ivp .ge. nv-3*nx) then
       write(29,3) zeit,0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
       vx = 0.0
       vy = 0.0
       vz = 0.0
      else
       write(29,3) zeit,pmax,xp,yp,rho(ivp),bx(ivp),by(ivp),bz(ivp)
      end if

      if(mod(ivbp,nx).le.3 .or. mod(ivbp,nx).ge.nx-3 
     +       .or. ivbp .ge. nv-3*nx) then
         write(29,4) 0.0, 0.0, 0.0,vx,vy,vz
         delb = 0.0
         delx = 0.0
         dely = 0.0
      else
         write(29,4) bnp,xbp,ybp,vx,vy,vz
      end if

      if(mod(ivbm,nx).le.3 .or. mod(ivbm,nx).ge.nx-3 
     +       .or. ivbm .ge. nv-3*nx) then
         write(29,5) 0.0, 0.0, 0.0, delb,delx,dely
      else
         write(29,5) bnm,xbm,ybm,delb,delx,dely
      end if

    3 format(1x,f7.2,3f9.3,f8.3,3f9.3)
    4 format(9x,3f9.3,7x,3f9.3)
    5 format(10x,3f9.3,2x,3f9.3)
c
c
      return
      end
	subroutine diag4
c
	include 'hinclude.f'
c
        integer  iv,nvp0,nxe,iaa,ibb
        real     aflux,bflux,xflux,vxmax,vxmin
        real     bmax(4,3), bmin(4,3), vmax(4,3), vmin(4,3),
     +           jmax(4,3), jmin(4,3), emax(4,3), emin(4,3),
     +           jemin(2,3),jemax(2,3),prho(3,3)

c.....................................................
c   diagnostics to determine 
c   a: total mass and energy
c   b: magn. field reversal, no and position of x lines 
c   c: tearing mode growth rate
c.....................................................
c
c   a: computation of total mass and energy
c-----------------------------------------
      nxe = (nx+1)/2
      
      nvp0 = nv+1
      do 40 iv = 1,nv
        help(iv)  = u(iv)**gamma
	hilf(iv)  = 0.25/difx(iv)/dify(iv)
   40 continue

      do 50 iv = nx+2,nv-nx-1
        if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
          feldx(iv) =  dify(iv)*(bz(iv+nx)-bz(iv-nx))
          feldy(iv) = -difx(iv)*(bz(iv+1)-bz(iv-1))
          feldz(iv) = difx(iv)*(by(iv+1)-by(iv-1))
     +               -dify(iv)*(bx(iv+nx)-bx(iv-nx))
          hilfx(iv) = ( sx(iv)*difx(iv)*(help(iv+1)-help(iv-1))
     +                + sy(iv)*dify(iv)*(help(iv+nx)-help(iv-nx)) )
     +                             /rho(iv)
        else
	    feldx(iv) = 0.0
	    feldy(iv) = 0.0
	    feldz(iv) = 0.0
	    hilfx(iv) = 0.0
        end if
   50 continue
c
c    help = .5*pressure;  feld = current density
c
      do 100 iv = nx+2,nv-nx-1
        hilfy(iv) = ( sx(iv)*( feldy(iv)*bz(iv)-feldz(iv)*by(iv) )
     +              + sy(iv)*( feldz(iv)*bx(iv)-feldx(iv)*bz(iv) )
     +              + sz(iv)*( feldx(iv)*by(iv)-feldy(iv)*bx(iv) )
     +                            )/rho(iv)
        hilfz(iv) = res(iv)*( feldx(iv)*feldx(iv)
     +                      + feldy(iv)*feldy(iv)
     +                      + feldz(iv)*feldz(iv) )
  100 continue
c
c        hilfx = geschw. * grad (druck/2)
c        hilfy = stromd. * (geschw. x magnetfeld)
c        hilfz = res. * stomd.**2
c
c 
      do 700 icomp = 1,4
        bmax(icomp,1) = -100.0
        bmin(icomp,1) =  100.0
        vmax(icomp,1) = -100.0
        vmin(icomp,1) =  100.0
        jmax(icomp,1) = -100.0
        jmin(icomp,1) =  100.0
        emax(icomp,1) = -100.0
        emin(icomp,1) =  100.0
  700 continue
      jemin(1,1) = 100.0
      jemin(2,1) = 100.0
      jemax(1,1) = -100.0
      jemax(2,1) = -100.0
      prho(1,1) = -100.0
      prho(2,1) = -100.0
      prho(3,1) = -100.0
      do 710 iv = nx+2,nv-nx-1
        hilfx(iv) = res(iv)*feldx(iv) - (
     +                     sy(iv)*bz(iv)
     +                   + sz(iv)*by(iv) )/rho(iv)
        hilfy(iv) = res(iv)*feldy(iv) - (
     +                     sz(iv)*bx(iv)
     +                   + sx(iv)*bz(iv) )/rho(iv)
        hilfz(iv) = res(iv)*feldz(iv) - (
     +                     sx(iv)*by(iv)
     +                   + sy(iv)*bx(iv) )/rho(iv)
  710 continue
      do 800 iv = nx+2,nv-nx-1
       if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
        if (bmax(1,1).lt.bx(iv) ) then
          bmax(1,1)=bx(iv)
          bmax(1,2)=x(iv)
          bmax(1,3)=y(iv)
         end if
        if (bmax(2,1).lt.by(iv) ) then
          bmax(2,1)=by(iv)
          bmax(2,2)=x(iv)
          bmax(2,3)=y(iv)
         end if
        if (bmax(3,1).lt.bz(iv) ) then
          bmax(3,1)=bz(iv)
          bmax(3,2)=x(iv)
          bmax(3,3)=y(iv)
         end if
        if (bmin(1,1).gt.bx(iv) ) then
          bmin (1,1)=bx(iv)
          bmin (1,2)=x(iv)
          bmin (1,3)=y(iv)
         end if
        if (bmin(2,1).gt.by(iv) ) then
          bmin (2,1)=by(iv)
          bmin (2,2)=x(iv)
          bmin (2,3)=y(iv)
         end if
        if (bmin(3,1).gt.bz(iv) ) then
          bmin (3,1)=bz(iv)
          bmin (3,2)=x(iv)
          bmin (3,3)=y(iv)
         end if
        if (vmax(1,1).lt.sx(iv)/rho(iv) ) then
          vmax(1,1)=sx(iv)/rho(iv)
          vmax(1,2)=x(iv)
          vmax(1,3)=y(iv)
         end if
        if (vmax(2,1).lt.sy(iv)/rho(iv) ) then
          vmax(2,1)=sy(iv)/rho(iv)
          vmax(2,2)=x(iv)
          vmax(2,3)=y(iv)
         end if
        if (vmax(3,1).lt.sz(iv)/rho(iv) ) then
          vmax(3,1)=sz(iv)/rho(iv)
          vmax(3,2)=x(iv)
          vmax(3,3)=y(iv)
         end if
        if (vmin(1,1).gt.sx(iv)/rho(iv) ) then
          vmin (1,1)=sx(iv)/rho(iv)
          vmin (1,2)=x(iv)
          vmin (1,3)=y(iv)
         end if
        if (vmin(2,1).gt.sy(iv)/rho(iv) ) then
          vmin (2,1)=sy(iv)/rho(iv)
          vmin (2,2)=x(iv)
          vmin (2,3)=y(iv)
         end if
        if (vmin(3,1).gt.sz(iv)/rho(iv) ) then
          vmin (3,1)=sz(iv)/rho(iv)
          vmin (3,2)=x(iv)
          vmin (3,3)=y(iv)
         end if
        if (jmax(1,1).lt.feldx(iv) ) then
          jmax(1,1)=feldx(iv)
          jmax(1,2)=x(iv)
          jmax(1,3)=y(iv)
         end if
        if (jmax(2,1).lt.feldy(iv) ) then
          jmax(2,1)=feldy(iv)
          jmax(2,2)=x(iv)
          jmax(2,3)=y(iv)
         end if
        if (jmax(3,1).lt.feldz(iv) ) then
          jmax(3,1)=feldz(iv)
          jmax(3,2)=x(iv)
          jmax(3,3)=y(iv)
         end if
        if (jmin(1,1).gt.feldx(iv) ) then
          jmin (1,1)=feldx(iv)
          jmin (1,2)=x(iv)
          jmin (1,3)=y(iv)
         end if
        if (jmin(2,1).gt.feldy(iv) ) then
          jmin (2,1)=feldy(iv)
          jmin (2,2)=x(iv)
          jmin (2,3)=y(iv)
         end if
        if (jmin(3,1).gt.feldz(iv) ) then
          jmin (3,1)=feldz(iv)
          jmin (3,2)=x(iv)
          jmin (3,3)=y(iv)
         end if
        if (emax(1,1).lt.hilfx(iv) ) then
          emax(1,1)=hilfx(iv)
          emax(1,2)=x(iv)
          emax(1,3)=y(iv)
         end if
        if (emax(2,1).lt.hilfy(iv) ) then
          emax(2,1)=hilfy(iv)
          emax(2,2)=x(iv)
          emax(2,3)=y(iv)
         end if
        if (emax(3,1).lt.hilfz(iv) ) then
          emax(3,1)=hilfz(iv)
          emax(3,2)=x(iv)
          emax(3,3)=y(iv)
         end if
        if (emin(1,1).gt.hilfx(iv) ) then
          emin (1,1)=hilfx(iv)
          emin (1,2)=x(iv)
          emin (1,3)=y(iv)
         end if
        if (emin(2,1).gt.hilfy(iv) ) then
          emin (2,1)=hilfy(iv)
          emin (2,2)=x(iv)
          emin (2,3)=y(iv)
         end if
        if (emin(3,1).gt.hilfz(iv) ) then
          emin (3,1)=hilfz(iv)
          emin (3,2)=x(iv)
          emin (3,3)=y(iv)
         end if
       end if
  800 continue

      do 810 iv = nx+2,nv-nx-1
        hilf(iv) = sqrt( hilfx(iv)*hilfx(iv)
     +                   + hilfy(iv)*hilfy(iv)
     +                   + hilfz(iv)*hilfz(iv) )
        hilfx(iv) = sqrt( bx(iv)*bx(iv)
     +                   + by(iv)*by(iv)
     +                   + bz(iv)*bz(iv) )
        hilfy(iv) = sqrt( sx(iv)*sx(iv)
     +                   + sy(iv)*sy(iv)
     +                   + sz(iv)*sz(iv) )/rho(iv)
        hilfz(iv) = sqrt( feldx(iv)*feldx(iv)
     +                   + feldy(iv)*feldy(iv)
     +                   + feldz(iv)*feldz(iv) )
  810 continue
      do 820 iv = nx+2,nv-nx-1
       if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
        if (bmax(4,1).lt.hilfx(iv) ) then
          bmax(4,1)=hilfx(iv)
          bmax(4,2)=x(iv)
          bmax(4,3)=y(iv)
         end if
        if (vmax(4,1).lt.hilfy(iv) ) then
          vmax(4,1)=hilfy(iv)
          vmax(4,2)=x(iv)
          vmax(4,3)=y(iv)
         end if
        if (jmax(4,1).lt.hilfz(iv) ) then
          jmax(4,1)=hilfz(iv)
          jmax(4,2)=x(iv)
          jmax(4,3)=y(iv)
         end if
        if (emax(4,1).lt.hilf(iv) ) then
          emax(4,1)=hilf(iv)
          emax(4,2)=x(iv)
          emax(4,3)=y(iv)
         end if
       end if
  820 continue

      do 830 iv = nx+2,nv-nx-1
        if (hilfx(iv).ne.0.0) then
            hilf(iv) = ( bx(iv)*feldx(iv)
     +                       + by(iv)*feldy(iv)
     +                       + bz(iv)*feldz(iv) )
     +                       /hilfx(iv)
        else
            hilf(iv) = 0.0
        end if  
  830 continue
      do 835 iv = nx+2,nv-nx-1
        hilfy(iv) =  hilf(iv)*res(iv)
        hilfz(iv) = 2*help(iv) + hilfx(iv)*hilfx(iv)
  835 continue
      do 840 iv = nx+2,nv-nx-1
       if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
        if (jemin(1,1).gt.hilf(iv) ) then
          jemin(1,1)=hilf(iv)
          jemin(1,2)=x(iv)
          jemin(1,3)=y(iv)
         end if
        if (jemin(2,1).gt.hilfy(iv) ) then
          jemin(2,1)=hilfy(iv)
          jemin(2,2)=x(iv)
          jemin(2,3)=y(iv)
         end if
        if (jemax(1,1).lt.hilf(iv) ) then
          jemax(1,1)=hilf(iv)
          jemax(1,2)=x(iv)
          jemax(1,3)=y(iv)
         end if
        if (jemax(2,1).lt.hilfy(iv) ) then
          jemax(2,1)=hilfy(iv)
          jemax(2,2)=x(iv)
          jemax(2,3)=y(iv)
         end if

        if (prho(1,1).lt.hilfz(iv) ) then
          prho(1,1)=hilfz(iv)
          prho(1,2)=x(iv)
          prho(1,3)=y(iv)
         end if
        if (prho(2,1).lt. 2.*help(iv) ) then
          prho(2,1)=2.*help(iv)
          prho(2,2)=x(iv)
          prho(2,3)=y(iv)
         end if
        if (prho(3,1).lt.rho(iv) ) then
          prho(3,1)=rho(iv)
          prho(3,2)=x(iv)
          prho(3,3)=y(iv)
         end if
       end if
  840 continue

      write(23,11) zeit
      write(23,12) bmax(1,1),bmax(1,2),bmax(1,3),
     +             bmin(1,1),bmin(1,2),bmin(1,3)
      write(23,13) bmax(2,1),bmax(2,2),bmax(2,3),
     +             bmin(2,1),bmin(2,2),bmin(2,3)
      write(23,13) bmax(3,1),bmax(3,2),bmax(3,3),
     +             bmin(3,1),bmin(3,2),bmin(3,3)
      write(23,13) bmax(4,1),bmax(4,2),bmax(4,3)
      write(23,14) vmax(1,1),vmax(1,2),vmax(1,3),
     +             vmin(1,1),vmin(1,2),vmin(1,3)
      write(23,13) vmax(2,1),vmax(2,2),vmax(2,3),
     +             vmin(2,1),vmin(2,2),vmin(2,3)
      write(23,13) vmax(3,1),vmax(3,2),vmax(3,3),
     +             vmin(3,1),vmin(3,2),vmin(3,3)
      write(23,13) vmax(4,1),vmax(4,2),vmax(4,3)
      write(23,15) jmax(1,1),jmax(1,2),jmax(1,3),
     +             jmin(1,1),jmin(1,2),jmin(1,3)
      write(23,13) jmax(2,1),jmax(2,2),jmax(2,3),
     +             jmin(2,1),jmin(2,2),jmin(2,3)
      write(23,13) jmax(3,1),jmax(3,2),jmax(3,3),
     +             jmin(3,1),jmin(3,2),jmin(3,3)
      write(23,13) jmax(4,1),jmax(4,2),jmax(4,3)
      write(23,16) emax(1,1),emax(1,2),emax(1,3),
     +             emin(1,1),emin(1,2),emin(1,3)
      write(23,13) emax(2,1),emax(2,2),emax(2,3),
     +             emin(2,1),emin(2,2),emin(2,3)
      write(23,13) emax(3,1),emax(3,2),emax(3,3),
     +             emin(3,1),emin(3,2),emin(3,3)
      write(23,13) emax(4,1),emax(4,2),emax(4,3)
      write(23,17) jemax(1,1),jemax(1,2),jemax(1,3),
     +             jemin(1,1),jemin(1,2),jemin(1,3)
      write(23,13) jemax(2,1),jemax(2,2),jemax(2,3),
     +             jemin(2,1),jemin(2,2),jemin(2,3)
      write(23,18) prho(1,1),prho(1,2),prho(1,3)
      write(23,13) prho(2,1),prho(2,2),prho(2,3)
      write(23,13) prho(3,1),prho(3,2),prho(3,3)

      iaa=(nx+1)/2.
      ibb=(ny+1)/2.
      vxmax=-1000.
      vxmin=1000.
      aflux=0.
      do 597 iy=1,ny
      aflux=sx((iy-1)*nx+iaa)/rho((iy-1)*nx+iaa)
      if(aflux .gt. vxmax) vxmax=aflux
      if(aflux .lt. vxmin) vxmin=aflux
  597 continue
      vxmax=abs(vxmax-vxmin)
      feldz((ny-1)*nx+iaa) =1./(x((ny-1)*nx+iaa+1)-x((ny-1)*nx+iaa-1))*
     +     (by((ny-1)*nx+iaa+1)-by((ny-1)*nx+iaa-1))
     +               -0.5/(y((ny-1)*nx+iaa)-y((ny-2)*nx+iaa))*
     +              (bx(nx+iaa)-bx((ny-2)*nx+iaa))
      aflux=0.0
      bflux=0.0
      if(ischritt.eq.2*idiag) then
      arefer=0.
      zeit1=0.
      write(50, 29)res(1)
   29 format(f10.6)
      brefer=0.
      endif
      xflux=sx((ibb-1)*nx+iaa)/rho((ibb-1)*nx+iaa)*by((ibb-1)*nx+iaa)
     +      +sy((ibb-1)*nx+iaa)/rho((ibb-1)*nx+iaa)*bx((ibb-1)*nx+iaa)
     +      +res((ibb-1)*nx+iaa)*feldz((ibb-1)*nx+iaa)
      xflux=xflux*(zeit-zeit1)
      arefer=arefer+xflux
      aflux=arefer
      xflux=sx((ny-1)*nx+iaa)/rho((ny-1)*nx+iaa)*by((ny-1)*nx+iaa)
     +      -sy((ny-1)*nx+iaa)/rho((ny-1)*nx+iaa)*bx((ny-1)*nx+iaa)
     +      +res((ny-1)*nx+iaa)*feldz((ny-1)*nx+iaa)
      xflux=xflux*(zeit-zeit1)
      brefer=brefer+xflux
      bflux=brefer
      write(50, 19)zeit,jmax(4,1),jmax(4,2),jmax(4,3),
     +           aflux
      aflux=0.0
      do 569 iy=ibb,ny-1
      aflux=aflux+(bx(iy*nx+iaa)+bx((iy-1)*nx+iaa))/2.0
     +        *(y((iy*nx)+iaa)-y((iy-1)*nx+iaa))
  569 continue
      write(50,19)bflux,aflux,vxmax, 
     +            feldz((ibb-1)*nx+iaa),feldz((ny-1)*nx+iaa)
      zeit1=zeit
   11 format(f8.2)
   12 format(f11.4,2f8.2,f11.4,2f8.2,3x,'B')
   13 format(f11.4,2f8.2,f11.4,2f8.2)
   14 format(f11.4,2f8.2,f11.4,2f8.2,3x,'V')
   15 format(f11.4,2f8.2,f11.4,2f8.2,3x,'J')
   16 format(f11.4,2f8.2,f11.4,2f8.2,3x,'E')
   17 format(f11.4,2f8.2,f11.4,2f8.2,3x,'J,E ll')
   18 format(f11.4,2f8.2,36x,'PB,P,Rho')
   19 format(5f11.5)
c
      return
      end
	subroutine diagout
c
	include 'hinclude.f'
c
        real rrho,rekin,rethe,reb,rebi,rebr
	integer  i
c ....................................................
c     formatted output of diagnostics
c ....................................................
      
      do 1100 i = 1,ldiag
            rrho = 0.0
            rekin = 0.0
            rethe = 0.0
            reb = 0.0
            rebi = 0.0
            rebr = 0.0
          if (abs(fphi(i)).gt. 0.01) then 
            rrho = frho(i)/fphi(i)
            rekin = fekin(i)/fphi(i)
            rethe = fethe(i)/fphi(i)
            reb = feb(i)/fphi(i)
            rebi = febi(i)/fphi(i)
            rebr = febr(i)/fphi(i)
          end if

	  write(17,1) tdiag(i),mass(i),massu(i),
     +                         enkin(i),enmag(i),enthe(i)
	  write(18,2) tdiag(i),vgradp(i),vdjxb(i),resj2(i),
     +                ekinpu(i),ebpu(i),ethpu(i)
	  write(27,3) tdiag(i),fphi(i),fphip(i),fphipi(i),fphipr(i)
	  write(28,2) tdiag(i),frho(i),fekin(i),fethe(i),
     +                feb(i),febi(i),febr(i)
	  write(28,4) rrho,rekin,rethe,
     +                reb,rebi,rebr
 1100 continue

      do 1200 i = 1,ndiag
	  mass(i)  = 0.
	  massu(i)  = 0.
	  enmag(i) = 0.
 	  enkin(i) = 0.
	  enthe(i) = 0.
	  vgradp(i) = 0.
	  vdjxb(i) = 0.
	  resj2(i) = 0.
	  ekinpu(i)  = 0.
	  ethpu(i)   = 0.
	  ebpu(i)    = 0.
	  tdiag(i)   = 0.
          fphi(i)   = 0.
          fphip(i)  = 0.
          fphipi(i) = 0.
          fphipr(i) = 0.
          frho(i)   = 0.
          fekin(i)  = 0.
          fethe(i)  = 0.
          feb(i)    = 0.
          febi(i)   = 0.
          febr(i)   = 0.
 1200 continue
c
    1 format(1x,f7.3,' ',f12.2,' ',f12.2,' ',f12.3,' ',f12.2,' ',f12.2)
    2 format(1x,f7.3,' ',f10.4,' ',f10.4,' ',f10.4,' ',f10.4,
     +               ' ',f10.4,' ',f10.4 )
    3 format(1x,f7.3,' ',f12.4,' ',f12.4,' ',f12.4,' ',f12.4)
    4 format(5x,    '  ',f10.4,' ',f10.4,' ',f10.4,' ',f10.4,
     +               ' ',f10.4,' ',f10.4 )
c
      return
      end
	subroutine abbruch
c
	include 'hinclude.f'
c
	integer  ix,iy,iv,isum1,tstabb(nv),indiv(nv)
	real     absv,absv2,vmax
c ........................................................
c
c  test of  rho,u .lt.  or v .gt.  critical values
c  can lead to discontinuation of programm
c ........................................................
      vmax = 8.0
      do 20 iv = 1,nv
         tstabb(iv) = 0
   20 continue
      do 30 iv = nx+1,nv-nx-1
          if ( rho(iv) .le. 0.07 .or.
     +         u(iv) .le. 0.09  .or.
     +        ( sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +         + sz(iv)*sz(iv) )/(rho(iv)*rho(iv))
     +                   .ge. vmax**2 )  tstabb(iv) = 1
   30 continue
      isum1 = 0
      do 100 iv = nx+1,nv-nx-1
         isum1 = isum1 + tstabb(iv) 
  100 continue
  
      if (isum1 .ge. 1) then
         write(22,38) isum1
         fehler = .true.
         is = 0
         do 200 iv = 1,nv
           is = is + tstabb(iv)
           if (tstabb(iv).eq.1) indiv(is)=iv 
  200    continue
         do 210 is = 1,isum1
            iv = indiv(is)
            ix = mod(iv-1,nx)
            ix = ix+1
            iy = (iv-1)/nx
	    if ( rho(iv) .le. 0.07 ) then
	       write(22,39) ix,iy,rho(iv),zeit,ischritt,igrid
	       if (ix .eq. nx) write(22,49) rho(iv-2)
	       if (ix .eq. 1) write(22,59) rho(iv+2)
               rho(iv) = rhoprof(ix)
               write(22,*) 'corrected to:', rho(iv)
            endif
	    if ( u(iv) .le. 0.09 ) then
	       write(22,40) ix,iy,u(iv),zeit,ischritt,igrid
	       if (ix .eq. nx) write(22,50) u(iv-2)
	       if (ix .eq. 1) write(22,60) u(iv+2)
	       u(iv) = uprof(ix)
               write(22,*) 'corrected to:', u(iv)
            endif
            absv = sqrt( sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +                                 + sz(iv)*sz(iv) )/rho(iv)
	    if ( absv.gt.vmax) then
     	       write(22,41) ix,iy,absv,zeit,ischritt,igrid,
     +                  sx(iv)/rho(iv),sy(iv)/rho(iv),sz(iv)/rho(iv)
	       if (ix .eq. nx) write(22,51) 
     +             sx(iv-2),sy(iv-2),sz(iv-2),rho(iv-2)
	       if (ix .eq. 1) write(22,61) 
     +             sx(iv+2),sy(iv+2),sz(iv+2),rho(iv+2)
c                   sx(iv) = sx(iv)*vmax/absv 
c                   sy(iv) = sy(iv)*vmax/absv 
c                   sz(iv) = sz(iv)*vmax/absv 
            end if
  210    continue

         vphase=0.
         vpgrid=0.
         do 300 iv = nx+1,nv-nx-1
          if (mod(iv,nx).ne.0 .or. mod((iv-1),nx).ne.0) then
            help(iv) = sqrt ( bx(iv)*bx(iv) + by(iv)*by(iv)
     +            + bz(iv)*bz(iv) + gamma*u(iv)**gamma 
     +            + sx(iv)*sx(iv) + sy(iv)*sy(iv)
     +            + sz(iv)*sz(iv) )  /  rho(iv) 
            if ( vphase .lt. help(iv) ) then
              vphase=help(iv)
              ivphase=iv
            end if
            dgrid=max(difx(iv),dify(iv))
            if ( vpgrid .lt. dgrid*help(iv) ) then
              vpgrid=dgrid*help(iv)
              ivgrid=iv
            end if
          end if
  300    continue
         vpgrid=2.*vpgrid
         write(22,42) x(ivphase),y(ivphase),vphase,
     +                x(ivgrid),y(ivgrid),vpgrid,dt,zeit
         if (dt .gt. 0.5/vpgrid) then
           newdt = .true.
           write(22,43) 0.9*dt,zeit
         end if

      end if


   38 format(/,'No of errrors: ',i3 )
   39 format(' rho(',i3,',',i3,') =',f14.7,'   time =',f9.4,
     +       '   intstep=', i5,'   igrid:',i2 )
   49 format(' rho(ix-2)',f14.7)
   59 format(' rho(ix+2)',f14.7)
   40 format(' u(',i3,',',i3,') =',f14.7,'   time =',f9.4,
     +       '   intstep=', i5,'   igrid:',i2 )
   50 format(' u(ix-2)',f14.7)
   60 format(' u(ix+2)',f14.7)
   41 format(' abs v(',i3,',',i3,') =',f14.7,
     +       '   time =',f9.4,'   intstep=', i5,'   igrid:',i2,
     +       /,'   vx, vy, vz:',3f14.7 )
   51 format(' sx, sy, sz, rho at ix-2:',4f14.7)
   61 format(' sx, sy, sz, rho at ix+2:',4f14.7)
   42 format(' vphase(',f7.2,',',f7.2,') =',f8.3,
     +       /,'  vpgrid(',f7.2,',',f7.2,') =',f8.3,
     +       '  dt =', f8.5,'  time =', f9.5)
   43 format(' New Timestep dt =', f8.5,'  time =', f8.4)
c
      return
      end
	subroutine resbd
c
	include 'hinclude.f'
c       hier:      nx, ny, nv, ndiag
c       common:    mhdfeld, gitter, rkoeff, korand, progr,
c
	integer  iv, nx1, nx2, nx3,
     +           nv1,nv2,nv3,nv4,nv5,
     +           nxhalb,nyhalb,nvhalb
c ............................................................
c   berechnung der randwerte fuer die integrierten felder
c             (busrho)
c       f(i+1) = c1*f(i-1) + c2*f(i-3) + perio*f(n-3)
c                + lsym*f(sym)
c.............................................................
c     method=> subroutine rdkoef
c     (linesymmetry by lsym)
c
      nxhalb = (nx+1)/2
      nyhalb = (ny+1)/2
      nvhalb = (nv+1)/2
      nx1 = nx-1
      nx2 = nx-2
      nx3 = nx-3
      nv1 = nv-nx
      nv2 = nv-2*nx
      nv3 = nv-3*nx
      nv4 = nv-4*nx
      nv5 = nv-5*nx
c--------------------------------------
c   x = xmin
c       (liniensymmetrie entlang z-achse)
c--------------------------------------
      if ( perio(1) )  then
       do 110 iv = nx+1, nv1,nx
	 res(iv) = res(iv+nx3)
  110  continue
      else if ( lsym(1,1) ) then
       do 120 iv = nx+1, nv1,nx
	 res(iv) = res(nv1-iv+4)
  120  continue
      else
       do 140 iv = nx+1, nv1,nx
	 res(iv) = cres1(1,1)*res(iv+2) + cres2(1,1)*res(iv+4)
  140  continue
      end if
c--------------------------------------
c   x = xmax
c       (liniensymmetrie entlang z-achse)
c--------------------------------------
      if ( perio(1) )  then
       do 210 iv = 2*nx, nv1,nx
	res(iv) = res(iv-nx+3)
  210  continue
      else if ( lsym(2,1) )  then
       do 220 iv = 2*nx, nv1,nx
	res(iv) =  res(nv-iv+nx2)
  220  continue
      else
       do 240 iv = 2*nx, nv1,nx
	res(iv) = cres1(2,1)*res(iv-2) + cres2(2,1)*res(iv-4)
  240  continue
      end if
c--------------------------------------
c   y = ymin
c       (liniensymmetrie entlang x-achse)
c--------------------------------------
      if ( perio(2) )  then
       do 310 iv = 1, nx
	res(iv) = res(iv+nv3)
  310  continue
      else if ( lsym(1,2) )  then
       do 320 iv = 1, nx
	res(iv) =  res(3*nx+1-iv)
  320 continue
      else
       do 340 iv = 1, nx
	res(iv)   = cres1(1,2)*res(iv+2*nx)
     +                + cres2(1,2)*res(iv+4*nx)
  340  continue
      end if
c--------------------------------------
c   y = ymax
c       (liniensymmetrie entlang x-achse)
c--------------------------------------
      if ( perio(2) )  then
       do 410 iv = 1+nv1, nv
	res(iv) = res(iv-nv3)
  410  continue
      else if ( lsym(2,2) )  then
       do 420 iv = 1, nx
	res(nv-nx+iv) =  res(nv-2*nx+1-iv)
  420  continue
      else
       do 440 iv = 1+nv1, nv
	res(iv) = cres1(2,2)*res(iv-2*nx)
     +                + cres2(2,2)*res(iv-4*nx)
  440  continue
      end if
c
      return
      end
	subroutine resist
c
	include 'hinclude.f'
c
	integer  iv
	real     eta0,eta1,jcrit2,dtt
c
c************************************************
c    3.a resistivity
c    -------------------------------
c************************************************
c
      if (etasw .eq. 1 .and. eta.ne. 0.0) then
        eta0 = eta*( 1.0-exp(-zeit/5.0) )
        eta1 = 0.002
        do 10 iv = 1,nv
           res(iv) = eta0*prof(iv) + eta1
   10   continue
      end if
c
      if (etasw .ge. 2 .and. eta.ne. 0.0) then
        jcrit2=jcrit**2
c        write(*,*) jcrit, jcrit2
        eta0 = 0.0
c         eta0 = 0.1*eta*(exp(-zeit/8.0)-exp(-zeit/2.0))
        eta1 = 0.002*(1.0-exp(-zeit/5.0))
        do 100 iv = 1,nv
	  hilfy(iv) = res(iv)
	  res(iv) = 0.
	  hilfx(iv) = 0.
  100   continue

c    model 1
        if (etasw .eq. 2) then
         do 210 iv = nx + 2 + igrid,nv-nx-1,2
          if (helf(iv) .gt. jcrit2)  res(iv)=eta*(sqrt(helf(iv)-jcrit2))
  210    continue
        end if
c    model 2
        if (etasw .eq. 3) then
         do 220 iv = nx + 2 + igrid,nv-nx-1,2
          if (helf(iv) .gt. jcrit2)  res(iv)=eta*(sqrt(helf(iv))-jcrit)
  220    continue
        end if
c    model 3
        if (etasw .eq. 4) then
         do 230 iv = nx + 2 + igrid,nv-nx-1,2
          if (helf(iv) .gt. jcrit2)  res(iv)=eta*(helf(iv)-jcrit2)
  230    continue
        end if
        call resbd
        
        do 300 iv = nx + 3 - igrid,nv-nx-1,2
	  res(iv) = 0.5*( (meanpx(iv)*res(iv+1) + meanmx(iv)*res(iv-1))
     +           + (meanpy(iv)*res(iv+nx) + meanmy(iv)*res(iv-nx)))
  300   continue
        do 310 iv = 1,nv
           res(iv) = res(iv) + eta0*prof(iv) + eta1
  310   continue
        call resbd
        
        do 400 iv = nx+2,nv-nx-1
	  hilfx(iv) =  (1.-0.5/cosh(x(iv)/3.))*res(iv)
     +              + 0.25/cosh(x(iv)/3.)
     +              *( meanpx(iv)*res(iv+1) + meanmx(iv)*res(iv-1)
     +               + meanpy(iv)*res(iv+nx)+ meanmy(iv)*res(iv-nx) )
  400   continue
         dtt=1.0*dt
        epar1=1.0-dtt
        do 410 iv = nx+2,nv-nx-1
	  res(iv) = epar1*hilfy(iv)+dtt*hilfx(iv)
  410   continue
        call resbd
      end if
c
      return
      end
	subroutine trb
c
	include 'hinclude.f'
c
	integer  ix,iy,iv,tst
c ........................................................
c
c  test of  res .lt.0  or bz ne 0
c ........................................................
         tst = 0
      do 30 iv = 1,nv
          if ( res(iv) .lt. 0. .or.
     +         bz(iv) .ne. 0. .or. sz(iv) .ne. 0.)  tst = 1
   30 continue
      if (tst .eq. 1) then
       	 do 100 ix = 1,nx
       	 do 100 iy = 1,ny
	    iv  = ix+(iy-1)*nx
	    if ( res(iv) .lt. 0. ) then
	       write(*,39) ix,iy,res(iv),zeit
            endif
	    if ( bz(iv) .ne. 0. ) then
	       write(*,40) ix,iy,bz(iv),zeit
            endif
	    if ( sz(iv) .ne. 0. ) then
	       write(*,41) ix,iy,bz(iv),zeit
            endif
  100    continue
      end if

      if (tst .eq. 1) stop

   39 format(' res(',i3,',',i3,') =',f12.7,'   time =',f9.4)
   40 format(' bz(',i3,',',i3,') =',f12.7,'   time =',f9.4)
   41 format(' sz(',i3,',',i3,') =',f12.7,'   time =',f9.4)
c
      return
      end
      subroutine turbo

      include 'hinclude.f'

c     program written to check turbulence in current sheet
c     calculates enstrophy=mean square of vorticity


c
c      feld = curl s/rho
c              
      do 540 iv = nx+2,nv-nx-1
         if(mod(iv,nx).ne.0.and.mod(iv-1,nx).ne.0)then
            feldx(iv) =  dify(iv)*(sz(iv+nx)/rho(iv+nx)-
     +           sz(iv-nx)/rho(iv-nx))
            feldy(iv) = - difx(iv)*(sz(iv+1)/rho(iv+1)
     +           -sz(iv-1)/rho(iv-1))
            feldz(iv) =  difx(iv)*(sy(iv+1)/rho(iv+1)
     +           -sy(iv-1)/rho(iv-1))
     +           - dify(iv)*(sx(iv+nx)/rho(iv+nx)
     +           -sx(iv-nx)/rho(iv-nx))
         else
            feldx(iv)=0.
            feldy(iv)=0.
            feldz(iv)=0.
         endif

  540 continue

c     hilf = vorticity^2
c
      do 100 iv=nx+2,nv-nx-1
         hilf(iv) = feldx(iv)*feldx(iv)+feldy(iv)*feldy(iv)+
     +        feldz(iv)*feldz(iv)
 100  continue

      ncount=0
      summ=0.
      do 200 iv=nx+2,nv-nx-1
         if(hilf(iv).gt.0.)then
            ncount=ncount+1
            summ=summ+0.25*hilf(iv)/difx(iv)/dify(iv)
         endif
 200  continue

c      summ=0.5*summ/ncount

c     summ=enstrophy=mean square of vorticity 

      do 300 iv=1,nv
         hilf(iv)=sx(iv)*sx(iv)+sy(iv)*sy(iv)+sz(iv)*sz(iv)
         hilf(iv)=hilf(iv)/rho(iv)
 300  continue

      mcount=0
      ake=0.

      do 400 iv=1,nv
         if(hilf(iv).gt.0.)then
            mcount=mcount+1
            ake=ake+0.25*hilf(iv)/difx(iv)/dify(iv)
         endif
 400  continue
         
c      ake=0.5*ake/mcount
c     ake=mean square kinetic energy

      write(30,*)zeit,summ,ncount,ake,mcount

      return
      end
	subroutine fac
	
	include 'hinclude.f'
	
c	subroutine to save info about the field aligned currents 
c	generated during bz non-zero cases.

c     feld = current (j) ;   hilf = j dot b    

	do 50 iv = nx+2,nv-nx-1
        if(mod(iv,nx).ne.0 .and. mod(iv-1,nx).ne.0) then
          feldx(iv) =  dify(iv)*(bz(iv+nx)-bz(iv-nx))
          feldy(iv) = -difx(iv)*(bz(iv+1)-bz(iv-1))
          feldz(iv) = difx(iv)*(by(iv+1)-by(iv-1))
     +               -dify(iv)*(bx(iv+nx)-bx(iv-nx))
        else
            feldx(iv) = 0.0
            feldy(iv) = 0.0
            feldz(iv) = 0.0
            hilfx(iv) = 0.0
        end if
   50 continue


      do 100 iv=nx+2,nv-nx-1
         hilf(iv) = bx(iv)*feldx(iv)+by(iv)*feldy(iv)+
     +        bz(iv)*feldz(iv)
 100  continue
 	xjdb=0.
 	xbz=0.
      do 150 iv=nx+2,nv-nx-1
         if(hilf(iv).gt.xjdb)then 
         xjdb=hilf(iv)
         mivj=iv
         endif
         
         if(bz(iv).gt.xbz)then
         xbz=bz(iv)
         mivb=iv
         endif
 150   continue      
 
 	write(37,*)zeit, xjdb, mivj, xbz, mivb
 	
 	return
 	end
